#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 125
#define SYMBOL_COUNT 77
#define ALIAS_COUNT 4
#define TOKEN_COUNT 47
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_disjunction_delimiter = 1,
  anon_sym_STAR = 2,
  anon_sym_QMARK = 3,
  anon_sym_PLUS = 4,
  anon_sym_LBRACE = 5,
  aux_sym_count_quantifier_token1 = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_QMARK_EQ = 9,
  anon_sym_QMARK_BANG = 10,
  anon_sym_QMARK_LT_EQ = 11,
  anon_sym_QMARK_LT_BANG = 12,
  anon_sym_BSLASH = 13,
  aux_sym_backreference_escape_token1 = 14,
  anon_sym_BSLASHk_LT = 15,
  anon_sym_GT = 16,
  anon_sym_QMARK_LT = 17,
  sym__name_first_char = 18,
  sym__name_additional_char = 19,
  sym_non_capturing_group_identifier = 20,
  sym_group_begin = 21,
  sym_group_end = 22,
  anon_sym_LBRACK = 23,
  anon_sym_CARET = 24,
  anon_sym_DASH = 25,
  anon_sym_RBRACK = 26,
  anon_sym_BSLASHb = 27,
  aux_sym_set_octal_escape_token1 = 28,
  aux_sym_set_identity_escape_token1 = 29,
  sym__set_character = 30,
  sym_character_class_escape = 31,
  aux_sym_identity_escape_token1 = 32,
  anon_sym_BSLASH0 = 33,
  aux_sym_octal_escape_token1 = 34,
  anon_sym_BSLASHu = 35,
  aux_sym_unicode_escape_token1 = 36,
  anon_sym_BSLASHx = 37,
  aux_sym_hexadecimal_escape_token1 = 38,
  anon_sym_BSLASHc = 39,
  aux_sym_control_letter_escape_token1 = 40,
  sym_special_escape = 41,
  sym_end_assertion = 42,
  sym_non_boundary_assertion = 43,
  sym_any_character = 44,
  sym__pattern_character = 45,
  sym_null_character = 46,
  sym_regex = 47,
  sym_disjunction = 48,
  sym_zero_or_more = 49,
  sym_one_or_more = 50,
  sym_optional = 51,
  sym_count_quantifier = 52,
  sym_lookahead_assertion = 53,
  sym_negative_lookahead_assertion = 54,
  sym_lookbehind_assertion = 55,
  sym_negative_lookbehind_assertion = 56,
  sym_backreference_escape = 57,
  sym_named_capturing_group = 58,
  sym_group_name = 59,
  sym_non_capturing_group = 60,
  sym_anonymous_capturing_group = 61,
  sym_character_set = 62,
  sym_character_range = 63,
  sym_set_octal_escape = 64,
  sym_set_identity_escape = 65,
  sym_identity_escape = 66,
  sym_octal_escape = 67,
  sym_unicode_escape = 68,
  sym_hexadecimal_escape = 69,
  sym_control_letter_escape = 70,
  sym_escape_operator = 71,
  sym_start_assertion = 72,
  sym_boundary_assertion = 73,
  aux_sym_pattern_repeat1 = 74,
  aux_sym_group_name_repeat1 = 75,
  aux_sym_character_set_repeat1 = 76,
  alias_sym_lazy = 77,
  alias_sym_named_capturing_group_identifier = 78,
  alias_sym_range_delimiter = 79,
  alias_sym_set_negation = 80,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_disjunction_delimiter] = "disjunction_delimiter",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_PLUS] = "+",
  [anon_sym_LBRACE] = "{",
  [aux_sym_count_quantifier_token1] = "count_quantifier_value",
  [anon_sym_COMMA] = "count_quantifier_delimiter",
  [anon_sym_RBRACE] = "}",
  [anon_sym_QMARK_EQ] = "lookahead_identifier",
  [anon_sym_QMARK_BANG] = "negative_lookahead_identifier",
  [anon_sym_QMARK_LT_EQ] = "lookbehind_identifier",
  [anon_sym_QMARK_LT_BANG] = "negative_lookbehind_identifier",
  [anon_sym_BSLASH] = "\\",
  [aux_sym_backreference_escape_token1] = "backreference_escape_token1",
  [anon_sym_BSLASHk_LT] = "\\k<",
  [anon_sym_GT] = ">",
  [anon_sym_QMARK_LT] = "named_capturing_group_identifier",
  [sym__name_first_char] = "_name_first_char",
  [sym__name_additional_char] = "_name_additional_char",
  [sym_non_capturing_group_identifier] = "non_capturing_group_identifier",
  [sym_group_begin] = "group_begin",
  [sym_group_end] = "group_end",
  [anon_sym_LBRACK] = "set_begin",
  [anon_sym_CARET] = "^",
  [anon_sym_DASH] = "-",
  [anon_sym_RBRACK] = "set_end",
  [anon_sym_BSLASHb] = "\\b",
  [aux_sym_set_octal_escape_token1] = "octal_code",
  [aux_sym_set_identity_escape_token1] = "set_identity_escape_token1",
  [sym__set_character] = "_set_character",
  [sym_character_class_escape] = "character_class_escape",
  [aux_sym_identity_escape_token1] = "identity_escape_token1",
  [anon_sym_BSLASH0] = "\\0",
  [aux_sym_octal_escape_token1] = "octal_code",
  [anon_sym_BSLASHu] = "\\u",
  [aux_sym_unicode_escape_token1] = "unicode_code",
  [anon_sym_BSLASHx] = "\\x",
  [aux_sym_hexadecimal_escape_token1] = "hexadecimal_code",
  [anon_sym_BSLASHc] = "\\c",
  [aux_sym_control_letter_escape_token1] = "control_letter_code",
  [sym_special_escape] = "special_escape",
  [sym_end_assertion] = "end_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [sym_any_character] = "any_character",
  [sym__pattern_character] = "_pattern_character",
  [sym_null_character] = "null_character",
  [sym_regex] = "regex",
  [sym_disjunction] = "disjunction",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_lookahead_assertion] = "lookahead_assertion",
  [sym_negative_lookahead_assertion] = "negative_lookahead_assertion",
  [sym_lookbehind_assertion] = "lookbehind_assertion",
  [sym_negative_lookbehind_assertion] = "negative_lookbehind_assertion",
  [sym_backreference_escape] = "backreference_escape",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_group_name] = "group_name",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_character_set] = "character_class",
  [sym_character_range] = "character_range",
  [sym_set_octal_escape] = "octal_escape",
  [sym_set_identity_escape] = "identity_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_octal_escape] = "octal_escape",
  [sym_unicode_escape] = "unicode_escape",
  [sym_hexadecimal_escape] = "hexadecimal_escape",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym_escape_operator] = "escape_operator",
  [sym_start_assertion] = "start_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [aux_sym_pattern_repeat1] = "pattern_repeat1",
  [aux_sym_group_name_repeat1] = "group_name_repeat1",
  [aux_sym_character_set_repeat1] = "character_set_repeat1",
  [alias_sym_lazy] = "lazy",
  [alias_sym_named_capturing_group_identifier] = "named_capturing_group_identifier",
  [alias_sym_range_delimiter] = "range_delimiter",
  [alias_sym_set_negation] = "set_negation",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_disjunction_delimiter] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_count_quantifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_EQ] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK_LT_BANG] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_backreference_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASHk_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_LT] = {
    .visible = true,
    .named = true,
  },
  [sym__name_first_char] = {
    .visible = false,
    .named = true,
  },
  [sym__name_additional_char] = {
    .visible = false,
    .named = true,
  },
  [sym_non_capturing_group_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_group_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_group_end] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHb] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_set_octal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_set_identity_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__set_character] = {
    .visible = false,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_identity_escape_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_BSLASH0] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_octal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHu] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_unicode_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHx] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_hexadecimal_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BSLASHc] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_control_letter_escape_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_special_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_character] = {
    .visible = false,
    .named = true,
  },
  [sym_null_character] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_negative_lookbehind_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_character_set] = {
    .visible = true,
    .named = true,
  },
  [sym_character_range] = {
    .visible = true,
    .named = true,
  },
  [sym_set_octal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_set_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_octal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_hexadecimal_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_group_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_named_capturing_group_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_range_delimiter] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_set_negation] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[12][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_special_escape,
  },
  [2] = {
    [1] = alias_sym_lazy,
  },
  [3] = {
    [1] = alias_sym_set_negation,
  },
  [4] = {
    [1] = alias_sym_range_delimiter,
  },
  [5] = {
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [6] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
  },
  [7] = {
    [0] = sym_special_escape,
    [1] = alias_sym_range_delimiter,
    [2] = sym_special_escape,
  },
  [8] = {
    [3] = alias_sym_lazy,
  },
  [9] = {
    [2] = alias_sym_named_capturing_group_identifier,
    [3] = alias_sym_named_capturing_group_identifier,
  },
  [10] = {
    [4] = alias_sym_lazy,
  },
  [11] = {
    [5] = alias_sym_lazy,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lookahead == 0;
  switch (state) {
    case 0:
      if (eof) ADVANCE(21);
      if (lookahead == '$') ADVANCE(66);
      if (lookahead == '(') ADVANCE(44);
      if (lookahead == ')') ADVANCE(45);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == ',') ADVANCE(28);
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '0') ADVANCE(27);
      if (lookahead == '>') ADVANCE(39);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(34);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead == '}') ADVANCE(29);
      if (lookahead == '\n' ||
          lookahead == '/') ADVANCE(53);
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(27);
      if (lookahead == 8204 ||
          lookahead == 8205) ADVANCE(42);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(27);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          ('b' <= lookahead && lookahead <= 'd') ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          ('r' <= lookahead && lookahead <= 't') ||
          lookahead == 'v' ||
          lookahead == 'w') ADVANCE(41);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(41);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == ':') ADVANCE(43);
      if (lookahead == '<') ADVANCE(40);
      if (lookahead == '=') ADVANCE(30);
      END_STATE();
    case 2:
      if (lookahead == ',') ADVANCE(28);
      if (lookahead == '>') ADVANCE(39);
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '}') ADVANCE(29);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 8204 ||
          lookahead == 8205) ADVANCE(42);
      END_STATE();
    case 3:
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 4:
      if (lookahead == '-') ADVANCE(48);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead == ']') ADVANCE(49);
      if (lookahead != 0) ADVANCE(53);
      END_STATE();
    case 5:
      if (lookahead == '0') ADVANCE(11);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(58);
      END_STATE();
    case 6:
      if (lookahead == '<') ADVANCE(38);
      END_STATE();
    case 7:
      if (lookahead == '\\') ADVANCE(8);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(41);
      END_STATE();
    case 8:
      if (lookahead == 'u') ADVANCE(59);
      END_STATE();
    case 9:
      if (lookahead == '}') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 10:
      if (lookahead == '8' ||
          lookahead == '9') ADVANCE(52);
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(51);
      if (lookahead != 0 &&
          lookahead != '0' &&
          lookahead != 'D' &&
          lookahead != 'S' &&
          lookahead != 'W' &&
          (lookahead < 'b' || 'd' < lookahead) &&
          lookahead != 'f' &&
          lookahead != 'n' &&
          (lookahead < 'r' || 't' < lookahead) &&
          lookahead != 'v' &&
          lookahead != 'w') ADVANCE(55);
      END_STATE();
    case 11:
      if (('1' <= lookahead && lookahead <= '7')) ADVANCE(57);
      END_STATE();
    case 12:
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(37);
      if (lookahead != 0 &&
          lookahead != '0' &&
          lookahead != 'D' &&
          lookahead != 'S' &&
          lookahead != 'W' &&
          (lookahead < 'b' || 'd' < lookahead) &&
          lookahead != 'f' &&
          lookahead != 'n' &&
          (lookahead < 'r' || 't' < lookahead) &&
          lookahead != 'v' &&
          lookahead != 'w') ADVANCE(55);
      END_STATE();
    case 13:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(62);
      END_STATE();
    case 14:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(60);
      END_STATE();
    case 15:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(13);
      END_STATE();
    case 16:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(14);
      END_STATE();
    case 17:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(16);
      END_STATE();
    case 18:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(17);
      END_STATE();
    case 19:
      if (eof) ADVANCE(21);
      if (lookahead == '$') ADVANCE(66);
      if (lookahead == '(') ADVANCE(44);
      if (lookahead == ')') ADVANCE(45);
      if (lookahead == '*') ADVANCE(23);
      if (lookahead == '+') ADVANCE(25);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '?') ADVANCE(24);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '{') ADVANCE(26);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '}') ADVANCE(69);
      END_STATE();
    case 20:
      if (eof) ADVANCE(21);
      if (lookahead == '$') ADVANCE(66);
      if (lookahead == '(') ADVANCE(44);
      if (lookahead == ')') ADVANCE(45);
      if (lookahead == '.') ADVANCE(68);
      if (lookahead == '?') ADVANCE(1);
      if (lookahead == '[') ADVANCE(46);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == '^') ADVANCE(47);
      if (lookahead == '|') ADVANCE(22);
      if (lookahead == '}') ADVANCE(29);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '/' &&
          lookahead != ']' &&
          lookahead != '{') ADVANCE(69);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_disjunction_delimiter);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_count_quantifier_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(27);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_QMARK_EQ);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_QMARK_BANG);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_EQ);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_QMARK_LT_BANG);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '0') ADVANCE(56);
      if (lookahead == 'B') ADVANCE(67);
      if (lookahead == 'b') ADVANCE(50);
      if (lookahead == 'c') ADVANCE(63);
      if (lookahead == 'k') ADVANCE(6);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(65);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          ('s' <= lookahead && lookahead <= 'w')) ADVANCE(54);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (lookahead == '0') ADVANCE(56);
      if (lookahead == 'b') ADVANCE(50);
      if (lookahead == 'c') ADVANCE(63);
      if (lookahead == 'u') ADVANCE(59);
      if (lookahead == 'x') ADVANCE(61);
      if (lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(65);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          ('s' <= lookahead && lookahead <= 'w')) ADVANCE(54);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(aux_sym_backreference_escape_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(37);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_BSLASHk_LT);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK_LT);
      if (lookahead == '!') ADVANCE(33);
      if (lookahead == '=') ADVANCE(32);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(sym__name_first_char);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym__name_additional_char);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(sym_non_capturing_group_identifier);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_group_begin);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_group_end);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_BSLASHb);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(aux_sym_set_octal_escape_token1);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(aux_sym_set_identity_escape_token1);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym__set_character);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(sym_character_class_escape);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(aux_sym_identity_escape_token1);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_BSLASH0);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(aux_sym_octal_escape_token1);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(aux_sym_octal_escape_token1);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(57);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_BSLASHu);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(aux_sym_unicode_escape_token1);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_BSLASHx);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(aux_sym_hexadecimal_escape_token1);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_BSLASHc);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(aux_sym_control_letter_escape_token1);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_special_escape);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym__pattern_character);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 20, .external_lex_state = 1},
  [2] = {.lex_state = 20, .external_lex_state = 1},
  [3] = {.lex_state = 20, .external_lex_state = 1},
  [4] = {.lex_state = 20, .external_lex_state = 1},
  [5] = {.lex_state = 20, .external_lex_state = 1},
  [6] = {.lex_state = 20, .external_lex_state = 1},
  [7] = {.lex_state = 20, .external_lex_state = 1},
  [8] = {.lex_state = 20, .external_lex_state = 1},
  [9] = {.lex_state = 20, .external_lex_state = 1},
  [10] = {.lex_state = 20, .external_lex_state = 1},
  [11] = {.lex_state = 20, .external_lex_state = 1},
  [12] = {.lex_state = 20, .external_lex_state = 1},
  [13] = {.lex_state = 20, .external_lex_state = 1},
  [14] = {.lex_state = 20, .external_lex_state = 1},
  [15] = {.lex_state = 20, .external_lex_state = 1},
  [16] = {.lex_state = 20, .external_lex_state = 1},
  [17] = {.lex_state = 20, .external_lex_state = 1},
  [18] = {.lex_state = 20, .external_lex_state = 1},
  [19] = {.lex_state = 20, .external_lex_state = 1},
  [20] = {.lex_state = 19, .external_lex_state = 1},
  [21] = {.lex_state = 19, .external_lex_state = 1},
  [22] = {.lex_state = 19, .external_lex_state = 1},
  [23] = {.lex_state = 19, .external_lex_state = 1},
  [24] = {.lex_state = 19, .external_lex_state = 1},
  [25] = {.lex_state = 19, .external_lex_state = 1},
  [26] = {.lex_state = 19, .external_lex_state = 1},
  [27] = {.lex_state = 19, .external_lex_state = 1},
  [28] = {.lex_state = 19, .external_lex_state = 1},
  [29] = {.lex_state = 19, .external_lex_state = 1},
  [30] = {.lex_state = 19, .external_lex_state = 1},
  [31] = {.lex_state = 19, .external_lex_state = 1},
  [32] = {.lex_state = 19, .external_lex_state = 1},
  [33] = {.lex_state = 19, .external_lex_state = 1},
  [34] = {.lex_state = 19, .external_lex_state = 1},
  [35] = {.lex_state = 19, .external_lex_state = 1},
  [36] = {.lex_state = 19, .external_lex_state = 1},
  [37] = {.lex_state = 19, .external_lex_state = 1},
  [38] = {.lex_state = 19, .external_lex_state = 1},
  [39] = {.lex_state = 19, .external_lex_state = 1},
  [40] = {.lex_state = 19, .external_lex_state = 1},
  [41] = {.lex_state = 19, .external_lex_state = 1},
  [42] = {.lex_state = 19, .external_lex_state = 1},
  [43] = {.lex_state = 19, .external_lex_state = 1},
  [44] = {.lex_state = 19, .external_lex_state = 1},
  [45] = {.lex_state = 19, .external_lex_state = 1},
  [46] = {.lex_state = 19, .external_lex_state = 1},
  [47] = {.lex_state = 19, .external_lex_state = 1},
  [48] = {.lex_state = 19, .external_lex_state = 1},
  [49] = {.lex_state = 19, .external_lex_state = 1},
  [50] = {.lex_state = 19, .external_lex_state = 1},
  [51] = {.lex_state = 19, .external_lex_state = 1},
  [52] = {.lex_state = 19, .external_lex_state = 1},
  [53] = {.lex_state = 19, .external_lex_state = 1},
  [54] = {.lex_state = 19, .external_lex_state = 1},
  [55] = {.lex_state = 3, .external_lex_state = 1},
  [56] = {.lex_state = 4, .external_lex_state = 1},
  [57] = {.lex_state = 4, .external_lex_state = 1},
  [58] = {.lex_state = 4, .external_lex_state = 1},
  [59] = {.lex_state = 4, .external_lex_state = 1},
  [60] = {.lex_state = 19, .external_lex_state = 1},
  [61] = {.lex_state = 19, .external_lex_state = 1},
  [62] = {.lex_state = 19, .external_lex_state = 1},
  [63] = {.lex_state = 19, .external_lex_state = 1},
  [64] = {.lex_state = 19, .external_lex_state = 1},
  [65] = {.lex_state = 19, .external_lex_state = 1},
  [66] = {.lex_state = 20, .external_lex_state = 1},
  [67] = {.lex_state = 20, .external_lex_state = 1},
  [68] = {.lex_state = 20, .external_lex_state = 1},
  [69] = {.lex_state = 20, .external_lex_state = 1},
  [70] = {.lex_state = 20, .external_lex_state = 1},
  [71] = {.lex_state = 20, .external_lex_state = 1},
  [72] = {.lex_state = 20, .external_lex_state = 1},
  [73] = {.lex_state = 4, .external_lex_state = 1},
  [74] = {.lex_state = 4, .external_lex_state = 1},
  [75] = {.lex_state = 4, .external_lex_state = 1},
  [76] = {.lex_state = 4, .external_lex_state = 1},
  [77] = {.lex_state = 4, .external_lex_state = 1},
  [78] = {.lex_state = 4, .external_lex_state = 1},
  [79] = {.lex_state = 4, .external_lex_state = 1},
  [80] = {.lex_state = 4, .external_lex_state = 1},
  [81] = {.lex_state = 4, .external_lex_state = 1},
  [82] = {.lex_state = 4, .external_lex_state = 1},
  [83] = {.lex_state = 4, .external_lex_state = 1},
  [84] = {.lex_state = 4, .external_lex_state = 1},
  [85] = {.lex_state = 4, .external_lex_state = 1},
  [86] = {.lex_state = 4, .external_lex_state = 1},
  [87] = {.lex_state = 4, .external_lex_state = 1},
  [88] = {.lex_state = 4, .external_lex_state = 1},
  [89] = {.lex_state = 4, .external_lex_state = 1},
  [90] = {.lex_state = 2},
  [91] = {.lex_state = 2},
  [92] = {.lex_state = 2},
  [93] = {.lex_state = 7},
  [94] = {.lex_state = 7},
  [95] = {.lex_state = 2},
  [96] = {.lex_state = 10},
  [97] = {.lex_state = 10},
  [98] = {.lex_state = 20},
  [99] = {.lex_state = 9},
  [100] = {.lex_state = 12},
  [101] = {.lex_state = 2},
  [102] = {.lex_state = 2},
  [103] = {.lex_state = 9},
  [104] = {.lex_state = 9},
  [105] = {.lex_state = 5},
  [106] = {.lex_state = 2},
  [107] = {.lex_state = 20},
  [108] = {.lex_state = 20},
  [109] = {.lex_state = 20},
  [110] = {.lex_state = 15},
  [111] = {.lex_state = 20},
  [112] = {.lex_state = 20},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 20},
  [115] = {.lex_state = 20},
  [116] = {.lex_state = 10},
  [117] = {.lex_state = 20},
  [118] = {.lex_state = 18},
  [119] = {.lex_state = 0},
  [120] = {.lex_state = 5},
  [121] = {.lex_state = 18},
  [122] = {.lex_state = 15},
  [123] = {.lex_state = 9},
  [124] = {.lex_state = 18},
};

enum {
  ts_external_token_null_character = 0,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_null_character] = sym_null_character,
};

static bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_null_character] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_disjunction_delimiter] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [aux_sym_count_quantifier_token1] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [aux_sym_backreference_escape_token1] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym__name_first_char] = ACTIONS(1),
    [sym__name_additional_char] = ACTIONS(1),
    [sym_group_begin] = ACTIONS(1),
    [sym_group_end] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [aux_sym_set_octal_escape_token1] = ACTIONS(1),
    [aux_sym_set_identity_escape_token1] = ACTIONS(1),
    [sym__set_character] = ACTIONS(1),
    [aux_sym_identity_escape_token1] = ACTIONS(1),
    [aux_sym_control_letter_escape_token1] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [sym__pattern_character] = ACTIONS(1),
    [sym_null_character] = ACTIONS(1),
  },
  [1] = {
    [sym_regex] = STATE(119),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(11),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [2] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(10),
    [anon_sym_QMARK_EQ] = ACTIONS(25),
    [anon_sym_QMARK_BANG] = ACTIONS(27),
    [anon_sym_QMARK_LT_EQ] = ACTIONS(29),
    [anon_sym_QMARK_LT_BANG] = ACTIONS(31),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [anon_sym_QMARK_LT] = ACTIONS(33),
    [sym_non_capturing_group_identifier] = ACTIONS(35),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(37),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [3] = {
    [sym_disjunction] = STATE(98),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(39),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(39),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [4] = {
    [sym_disjunction] = STATE(108),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [5] = {
    [sym_disjunction] = STATE(109),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(45),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [6] = {
    [sym_disjunction] = STATE(111),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(47),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [7] = {
    [sym_disjunction] = STATE(115),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(49),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [8] = {
    [sym_disjunction] = STATE(114),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [9] = {
    [sym_disjunction] = STATE(117),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(53),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [10] = {
    [sym_disjunction] = STATE(112),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [11] = {
    [sym_disjunction] = STATE(113),
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(57),
    [sym_disjunction_delimiter] = ACTIONS(41),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [12] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(12),
    [ts_builtin_sym_end] = ACTIONS(59),
    [sym_disjunction_delimiter] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(61),
    [anon_sym_BSLASHk_LT] = ACTIONS(64),
    [sym_group_begin] = ACTIONS(67),
    [sym_group_end] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(70),
    [anon_sym_CARET] = ACTIONS(73),
    [anon_sym_BSLASHb] = ACTIONS(76),
    [sym_character_class_escape] = ACTIONS(79),
    [anon_sym_BSLASH0] = ACTIONS(82),
    [anon_sym_BSLASHu] = ACTIONS(85),
    [anon_sym_BSLASHx] = ACTIONS(88),
    [anon_sym_BSLASHc] = ACTIONS(91),
    [sym_special_escape] = ACTIONS(79),
    [sym_end_assertion] = ACTIONS(79),
    [sym_non_boundary_assertion] = ACTIONS(79),
    [sym_any_character] = ACTIONS(79),
    [sym__pattern_character] = ACTIONS(79),
    [sym_null_character] = ACTIONS(79),
  },
  [13] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(94),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(94),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [14] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(6),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(96),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [15] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(5),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(98),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [16] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(9),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(100),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [17] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(8),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(102),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [18] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(4),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(104),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [19] = {
    [sym_lookahead_assertion] = STATE(20),
    [sym_negative_lookahead_assertion] = STATE(20),
    [sym_lookbehind_assertion] = STATE(20),
    [sym_negative_lookbehind_assertion] = STATE(20),
    [sym_backreference_escape] = STATE(20),
    [sym_named_capturing_group] = STATE(20),
    [sym_non_capturing_group] = STATE(20),
    [sym_anonymous_capturing_group] = STATE(20),
    [sym_character_set] = STATE(20),
    [sym_identity_escape] = STATE(20),
    [sym_octal_escape] = STATE(20),
    [sym_unicode_escape] = STATE(20),
    [sym_hexadecimal_escape] = STATE(20),
    [sym_control_letter_escape] = STATE(20),
    [sym_escape_operator] = STATE(116),
    [sym_start_assertion] = STATE(20),
    [sym_boundary_assertion] = STATE(20),
    [aux_sym_pattern_repeat1] = STATE(7),
    [anon_sym_BSLASH] = ACTIONS(3),
    [anon_sym_BSLASHk_LT] = ACTIONS(5),
    [sym_group_begin] = ACTIONS(7),
    [sym_group_end] = ACTIONS(106),
    [anon_sym_LBRACK] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [anon_sym_BSLASHb] = ACTIONS(13),
    [sym_character_class_escape] = ACTIONS(15),
    [anon_sym_BSLASH0] = ACTIONS(17),
    [anon_sym_BSLASHu] = ACTIONS(19),
    [anon_sym_BSLASHx] = ACTIONS(21),
    [anon_sym_BSLASHc] = ACTIONS(23),
    [sym_special_escape] = ACTIONS(15),
    [sym_end_assertion] = ACTIONS(15),
    [sym_non_boundary_assertion] = ACTIONS(15),
    [sym_any_character] = ACTIONS(15),
    [sym__pattern_character] = ACTIONS(15),
    [sym_null_character] = ACTIONS(15),
  },
  [20] = {
    [sym_zero_or_more] = STATE(71),
    [sym_one_or_more] = STATE(71),
    [sym_optional] = STATE(71),
    [sym_count_quantifier] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(108),
    [sym_disjunction_delimiter] = ACTIONS(108),
    [anon_sym_STAR] = ACTIONS(110),
    [anon_sym_QMARK] = ACTIONS(112),
    [anon_sym_PLUS] = ACTIONS(114),
    [anon_sym_LBRACE] = ACTIONS(116),
    [anon_sym_BSLASH] = ACTIONS(118),
    [anon_sym_BSLASHk_LT] = ACTIONS(108),
    [sym_group_begin] = ACTIONS(108),
    [sym_group_end] = ACTIONS(108),
    [anon_sym_LBRACK] = ACTIONS(108),
    [anon_sym_CARET] = ACTIONS(108),
    [anon_sym_BSLASHb] = ACTIONS(108),
    [sym_character_class_escape] = ACTIONS(108),
    [anon_sym_BSLASH0] = ACTIONS(108),
    [anon_sym_BSLASHu] = ACTIONS(108),
    [anon_sym_BSLASHx] = ACTIONS(108),
    [anon_sym_BSLASHc] = ACTIONS(108),
    [sym_special_escape] = ACTIONS(108),
    [sym_end_assertion] = ACTIONS(108),
    [sym_non_boundary_assertion] = ACTIONS(108),
    [sym_any_character] = ACTIONS(108),
    [sym__pattern_character] = ACTIONS(108),
    [sym_null_character] = ACTIONS(108),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(120),
    [sym_disjunction_delimiter] = ACTIONS(120),
    [anon_sym_STAR] = ACTIONS(120),
    [anon_sym_QMARK] = ACTIONS(120),
    [anon_sym_PLUS] = ACTIONS(120),
    [anon_sym_LBRACE] = ACTIONS(120),
    [anon_sym_BSLASH] = ACTIONS(122),
    [anon_sym_BSLASHk_LT] = ACTIONS(120),
    [sym_group_begin] = ACTIONS(120),
    [sym_group_end] = ACTIONS(120),
    [anon_sym_LBRACK] = ACTIONS(120),
    [anon_sym_CARET] = ACTIONS(120),
    [anon_sym_BSLASHb] = ACTIONS(120),
    [sym_character_class_escape] = ACTIONS(120),
    [anon_sym_BSLASH0] = ACTIONS(120),
    [anon_sym_BSLASHu] = ACTIONS(120),
    [anon_sym_BSLASHx] = ACTIONS(120),
    [anon_sym_BSLASHc] = ACTIONS(120),
    [sym_special_escape] = ACTIONS(120),
    [sym_end_assertion] = ACTIONS(120),
    [sym_non_boundary_assertion] = ACTIONS(120),
    [sym_any_character] = ACTIONS(120),
    [sym__pattern_character] = ACTIONS(120),
    [sym_null_character] = ACTIONS(120),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(124),
    [sym_disjunction_delimiter] = ACTIONS(124),
    [anon_sym_STAR] = ACTIONS(124),
    [anon_sym_QMARK] = ACTIONS(124),
    [anon_sym_PLUS] = ACTIONS(124),
    [anon_sym_LBRACE] = ACTIONS(124),
    [anon_sym_BSLASH] = ACTIONS(126),
    [anon_sym_BSLASHk_LT] = ACTIONS(124),
    [sym_group_begin] = ACTIONS(124),
    [sym_group_end] = ACTIONS(124),
    [anon_sym_LBRACK] = ACTIONS(124),
    [anon_sym_CARET] = ACTIONS(124),
    [anon_sym_BSLASHb] = ACTIONS(124),
    [sym_character_class_escape] = ACTIONS(124),
    [anon_sym_BSLASH0] = ACTIONS(124),
    [anon_sym_BSLASHu] = ACTIONS(124),
    [anon_sym_BSLASHx] = ACTIONS(124),
    [anon_sym_BSLASHc] = ACTIONS(124),
    [sym_special_escape] = ACTIONS(124),
    [sym_end_assertion] = ACTIONS(124),
    [sym_non_boundary_assertion] = ACTIONS(124),
    [sym_any_character] = ACTIONS(124),
    [sym__pattern_character] = ACTIONS(124),
    [sym_null_character] = ACTIONS(124),
  },
  [23] = {
    [ts_builtin_sym_end] = ACTIONS(128),
    [sym_disjunction_delimiter] = ACTIONS(128),
    [anon_sym_STAR] = ACTIONS(128),
    [anon_sym_QMARK] = ACTIONS(128),
    [anon_sym_PLUS] = ACTIONS(128),
    [anon_sym_LBRACE] = ACTIONS(128),
    [anon_sym_BSLASH] = ACTIONS(130),
    [anon_sym_BSLASHk_LT] = ACTIONS(128),
    [sym_group_begin] = ACTIONS(128),
    [sym_group_end] = ACTIONS(128),
    [anon_sym_LBRACK] = ACTIONS(128),
    [anon_sym_CARET] = ACTIONS(128),
    [anon_sym_BSLASHb] = ACTIONS(128),
    [sym_character_class_escape] = ACTIONS(128),
    [anon_sym_BSLASH0] = ACTIONS(128),
    [anon_sym_BSLASHu] = ACTIONS(128),
    [anon_sym_BSLASHx] = ACTIONS(128),
    [anon_sym_BSLASHc] = ACTIONS(128),
    [sym_special_escape] = ACTIONS(128),
    [sym_end_assertion] = ACTIONS(128),
    [sym_non_boundary_assertion] = ACTIONS(128),
    [sym_any_character] = ACTIONS(128),
    [sym__pattern_character] = ACTIONS(128),
    [sym_null_character] = ACTIONS(128),
  },
  [24] = {
    [ts_builtin_sym_end] = ACTIONS(132),
    [sym_disjunction_delimiter] = ACTIONS(132),
    [anon_sym_STAR] = ACTIONS(132),
    [anon_sym_QMARK] = ACTIONS(132),
    [anon_sym_PLUS] = ACTIONS(132),
    [anon_sym_LBRACE] = ACTIONS(132),
    [anon_sym_BSLASH] = ACTIONS(134),
    [anon_sym_BSLASHk_LT] = ACTIONS(132),
    [sym_group_begin] = ACTIONS(132),
    [sym_group_end] = ACTIONS(132),
    [anon_sym_LBRACK] = ACTIONS(132),
    [anon_sym_CARET] = ACTIONS(132),
    [anon_sym_BSLASHb] = ACTIONS(132),
    [sym_character_class_escape] = ACTIONS(132),
    [anon_sym_BSLASH0] = ACTIONS(132),
    [anon_sym_BSLASHu] = ACTIONS(132),
    [anon_sym_BSLASHx] = ACTIONS(132),
    [anon_sym_BSLASHc] = ACTIONS(132),
    [sym_special_escape] = ACTIONS(132),
    [sym_end_assertion] = ACTIONS(132),
    [sym_non_boundary_assertion] = ACTIONS(132),
    [sym_any_character] = ACTIONS(132),
    [sym__pattern_character] = ACTIONS(132),
    [sym_null_character] = ACTIONS(132),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(136),
    [sym_disjunction_delimiter] = ACTIONS(136),
    [anon_sym_STAR] = ACTIONS(136),
    [anon_sym_QMARK] = ACTIONS(136),
    [anon_sym_PLUS] = ACTIONS(136),
    [anon_sym_LBRACE] = ACTIONS(136),
    [anon_sym_BSLASH] = ACTIONS(138),
    [anon_sym_BSLASHk_LT] = ACTIONS(136),
    [sym_group_begin] = ACTIONS(136),
    [sym_group_end] = ACTIONS(136),
    [anon_sym_LBRACK] = ACTIONS(136),
    [anon_sym_CARET] = ACTIONS(136),
    [anon_sym_BSLASHb] = ACTIONS(136),
    [sym_character_class_escape] = ACTIONS(136),
    [anon_sym_BSLASH0] = ACTIONS(136),
    [anon_sym_BSLASHu] = ACTIONS(136),
    [anon_sym_BSLASHx] = ACTIONS(136),
    [anon_sym_BSLASHc] = ACTIONS(136),
    [sym_special_escape] = ACTIONS(136),
    [sym_end_assertion] = ACTIONS(136),
    [sym_non_boundary_assertion] = ACTIONS(136),
    [sym_any_character] = ACTIONS(136),
    [sym__pattern_character] = ACTIONS(136),
    [sym_null_character] = ACTIONS(136),
  },
  [26] = {
    [ts_builtin_sym_end] = ACTIONS(140),
    [sym_disjunction_delimiter] = ACTIONS(140),
    [anon_sym_STAR] = ACTIONS(140),
    [anon_sym_QMARK] = ACTIONS(140),
    [anon_sym_PLUS] = ACTIONS(140),
    [anon_sym_LBRACE] = ACTIONS(140),
    [anon_sym_BSLASH] = ACTIONS(142),
    [anon_sym_BSLASHk_LT] = ACTIONS(140),
    [sym_group_begin] = ACTIONS(140),
    [sym_group_end] = ACTIONS(140),
    [anon_sym_LBRACK] = ACTIONS(140),
    [anon_sym_CARET] = ACTIONS(140),
    [anon_sym_BSLASHb] = ACTIONS(140),
    [sym_character_class_escape] = ACTIONS(140),
    [anon_sym_BSLASH0] = ACTIONS(140),
    [anon_sym_BSLASHu] = ACTIONS(140),
    [anon_sym_BSLASHx] = ACTIONS(140),
    [anon_sym_BSLASHc] = ACTIONS(140),
    [sym_special_escape] = ACTIONS(140),
    [sym_end_assertion] = ACTIONS(140),
    [sym_non_boundary_assertion] = ACTIONS(140),
    [sym_any_character] = ACTIONS(140),
    [sym__pattern_character] = ACTIONS(140),
    [sym_null_character] = ACTIONS(140),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(144),
    [sym_disjunction_delimiter] = ACTIONS(144),
    [anon_sym_STAR] = ACTIONS(144),
    [anon_sym_QMARK] = ACTIONS(144),
    [anon_sym_PLUS] = ACTIONS(144),
    [anon_sym_LBRACE] = ACTIONS(144),
    [anon_sym_BSLASH] = ACTIONS(146),
    [anon_sym_BSLASHk_LT] = ACTIONS(144),
    [sym_group_begin] = ACTIONS(144),
    [sym_group_end] = ACTIONS(144),
    [anon_sym_LBRACK] = ACTIONS(144),
    [anon_sym_CARET] = ACTIONS(144),
    [anon_sym_BSLASHb] = ACTIONS(144),
    [sym_character_class_escape] = ACTIONS(144),
    [anon_sym_BSLASH0] = ACTIONS(144),
    [anon_sym_BSLASHu] = ACTIONS(144),
    [anon_sym_BSLASHx] = ACTIONS(144),
    [anon_sym_BSLASHc] = ACTIONS(144),
    [sym_special_escape] = ACTIONS(144),
    [sym_end_assertion] = ACTIONS(144),
    [sym_non_boundary_assertion] = ACTIONS(144),
    [sym_any_character] = ACTIONS(144),
    [sym__pattern_character] = ACTIONS(144),
    [sym_null_character] = ACTIONS(144),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(148),
    [sym_disjunction_delimiter] = ACTIONS(148),
    [anon_sym_STAR] = ACTIONS(148),
    [anon_sym_QMARK] = ACTIONS(148),
    [anon_sym_PLUS] = ACTIONS(148),
    [anon_sym_LBRACE] = ACTIONS(148),
    [anon_sym_BSLASH] = ACTIONS(150),
    [anon_sym_BSLASHk_LT] = ACTIONS(148),
    [sym_group_begin] = ACTIONS(148),
    [sym_group_end] = ACTIONS(148),
    [anon_sym_LBRACK] = ACTIONS(148),
    [anon_sym_CARET] = ACTIONS(148),
    [anon_sym_BSLASHb] = ACTIONS(148),
    [sym_character_class_escape] = ACTIONS(148),
    [anon_sym_BSLASH0] = ACTIONS(148),
    [anon_sym_BSLASHu] = ACTIONS(148),
    [anon_sym_BSLASHx] = ACTIONS(148),
    [anon_sym_BSLASHc] = ACTIONS(148),
    [sym_special_escape] = ACTIONS(148),
    [sym_end_assertion] = ACTIONS(148),
    [sym_non_boundary_assertion] = ACTIONS(148),
    [sym_any_character] = ACTIONS(148),
    [sym__pattern_character] = ACTIONS(148),
    [sym_null_character] = ACTIONS(148),
  },
  [29] = {
    [ts_builtin_sym_end] = ACTIONS(152),
    [sym_disjunction_delimiter] = ACTIONS(152),
    [anon_sym_STAR] = ACTIONS(152),
    [anon_sym_QMARK] = ACTIONS(152),
    [anon_sym_PLUS] = ACTIONS(152),
    [anon_sym_LBRACE] = ACTIONS(152),
    [anon_sym_BSLASH] = ACTIONS(154),
    [anon_sym_BSLASHk_LT] = ACTIONS(152),
    [sym_group_begin] = ACTIONS(152),
    [sym_group_end] = ACTIONS(152),
    [anon_sym_LBRACK] = ACTIONS(152),
    [anon_sym_CARET] = ACTIONS(152),
    [anon_sym_BSLASHb] = ACTIONS(152),
    [sym_character_class_escape] = ACTIONS(152),
    [anon_sym_BSLASH0] = ACTIONS(152),
    [anon_sym_BSLASHu] = ACTIONS(152),
    [anon_sym_BSLASHx] = ACTIONS(152),
    [anon_sym_BSLASHc] = ACTIONS(152),
    [sym_special_escape] = ACTIONS(152),
    [sym_end_assertion] = ACTIONS(152),
    [sym_non_boundary_assertion] = ACTIONS(152),
    [sym_any_character] = ACTIONS(152),
    [sym__pattern_character] = ACTIONS(152),
    [sym_null_character] = ACTIONS(152),
  },
  [30] = {
    [ts_builtin_sym_end] = ACTIONS(156),
    [sym_disjunction_delimiter] = ACTIONS(156),
    [anon_sym_STAR] = ACTIONS(156),
    [anon_sym_QMARK] = ACTIONS(156),
    [anon_sym_PLUS] = ACTIONS(156),
    [anon_sym_LBRACE] = ACTIONS(156),
    [anon_sym_BSLASH] = ACTIONS(158),
    [anon_sym_BSLASHk_LT] = ACTIONS(156),
    [sym_group_begin] = ACTIONS(156),
    [sym_group_end] = ACTIONS(156),
    [anon_sym_LBRACK] = ACTIONS(156),
    [anon_sym_CARET] = ACTIONS(156),
    [anon_sym_BSLASHb] = ACTIONS(156),
    [sym_character_class_escape] = ACTIONS(156),
    [anon_sym_BSLASH0] = ACTIONS(156),
    [anon_sym_BSLASHu] = ACTIONS(156),
    [anon_sym_BSLASHx] = ACTIONS(156),
    [anon_sym_BSLASHc] = ACTIONS(156),
    [sym_special_escape] = ACTIONS(156),
    [sym_end_assertion] = ACTIONS(156),
    [sym_non_boundary_assertion] = ACTIONS(156),
    [sym_any_character] = ACTIONS(156),
    [sym__pattern_character] = ACTIONS(156),
    [sym_null_character] = ACTIONS(156),
  },
  [31] = {
    [ts_builtin_sym_end] = ACTIONS(160),
    [sym_disjunction_delimiter] = ACTIONS(160),
    [anon_sym_STAR] = ACTIONS(160),
    [anon_sym_QMARK] = ACTIONS(160),
    [anon_sym_PLUS] = ACTIONS(160),
    [anon_sym_LBRACE] = ACTIONS(160),
    [anon_sym_BSLASH] = ACTIONS(162),
    [anon_sym_BSLASHk_LT] = ACTIONS(160),
    [sym_group_begin] = ACTIONS(160),
    [sym_group_end] = ACTIONS(160),
    [anon_sym_LBRACK] = ACTIONS(160),
    [anon_sym_CARET] = ACTIONS(160),
    [anon_sym_BSLASHb] = ACTIONS(160),
    [sym_character_class_escape] = ACTIONS(160),
    [anon_sym_BSLASH0] = ACTIONS(160),
    [anon_sym_BSLASHu] = ACTIONS(160),
    [anon_sym_BSLASHx] = ACTIONS(160),
    [anon_sym_BSLASHc] = ACTIONS(160),
    [sym_special_escape] = ACTIONS(160),
    [sym_end_assertion] = ACTIONS(160),
    [sym_non_boundary_assertion] = ACTIONS(160),
    [sym_any_character] = ACTIONS(160),
    [sym__pattern_character] = ACTIONS(160),
    [sym_null_character] = ACTIONS(160),
  },
  [32] = {
    [ts_builtin_sym_end] = ACTIONS(164),
    [sym_disjunction_delimiter] = ACTIONS(164),
    [anon_sym_STAR] = ACTIONS(164),
    [anon_sym_QMARK] = ACTIONS(164),
    [anon_sym_PLUS] = ACTIONS(164),
    [anon_sym_LBRACE] = ACTIONS(164),
    [anon_sym_BSLASH] = ACTIONS(166),
    [anon_sym_BSLASHk_LT] = ACTIONS(164),
    [sym_group_begin] = ACTIONS(164),
    [sym_group_end] = ACTIONS(164),
    [anon_sym_LBRACK] = ACTIONS(164),
    [anon_sym_CARET] = ACTIONS(164),
    [anon_sym_BSLASHb] = ACTIONS(164),
    [sym_character_class_escape] = ACTIONS(164),
    [anon_sym_BSLASH0] = ACTIONS(164),
    [anon_sym_BSLASHu] = ACTIONS(164),
    [anon_sym_BSLASHx] = ACTIONS(164),
    [anon_sym_BSLASHc] = ACTIONS(164),
    [sym_special_escape] = ACTIONS(164),
    [sym_end_assertion] = ACTIONS(164),
    [sym_non_boundary_assertion] = ACTIONS(164),
    [sym_any_character] = ACTIONS(164),
    [sym__pattern_character] = ACTIONS(164),
    [sym_null_character] = ACTIONS(164),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(168),
    [sym_disjunction_delimiter] = ACTIONS(168),
    [anon_sym_STAR] = ACTIONS(168),
    [anon_sym_QMARK] = ACTIONS(168),
    [anon_sym_PLUS] = ACTIONS(168),
    [anon_sym_LBRACE] = ACTIONS(168),
    [anon_sym_BSLASH] = ACTIONS(170),
    [anon_sym_BSLASHk_LT] = ACTIONS(168),
    [sym_group_begin] = ACTIONS(168),
    [sym_group_end] = ACTIONS(168),
    [anon_sym_LBRACK] = ACTIONS(168),
    [anon_sym_CARET] = ACTIONS(168),
    [anon_sym_BSLASHb] = ACTIONS(168),
    [sym_character_class_escape] = ACTIONS(168),
    [anon_sym_BSLASH0] = ACTIONS(168),
    [anon_sym_BSLASHu] = ACTIONS(168),
    [anon_sym_BSLASHx] = ACTIONS(168),
    [anon_sym_BSLASHc] = ACTIONS(168),
    [sym_special_escape] = ACTIONS(168),
    [sym_end_assertion] = ACTIONS(168),
    [sym_non_boundary_assertion] = ACTIONS(168),
    [sym_any_character] = ACTIONS(168),
    [sym__pattern_character] = ACTIONS(168),
    [sym_null_character] = ACTIONS(168),
  },
  [34] = {
    [ts_builtin_sym_end] = ACTIONS(172),
    [sym_disjunction_delimiter] = ACTIONS(172),
    [anon_sym_STAR] = ACTIONS(172),
    [anon_sym_QMARK] = ACTIONS(172),
    [anon_sym_PLUS] = ACTIONS(172),
    [anon_sym_LBRACE] = ACTIONS(172),
    [anon_sym_BSLASH] = ACTIONS(174),
    [anon_sym_BSLASHk_LT] = ACTIONS(172),
    [sym_group_begin] = ACTIONS(172),
    [sym_group_end] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(172),
    [anon_sym_CARET] = ACTIONS(172),
    [anon_sym_BSLASHb] = ACTIONS(172),
    [sym_character_class_escape] = ACTIONS(172),
    [anon_sym_BSLASH0] = ACTIONS(172),
    [anon_sym_BSLASHu] = ACTIONS(172),
    [anon_sym_BSLASHx] = ACTIONS(172),
    [anon_sym_BSLASHc] = ACTIONS(172),
    [sym_special_escape] = ACTIONS(172),
    [sym_end_assertion] = ACTIONS(172),
    [sym_non_boundary_assertion] = ACTIONS(172),
    [sym_any_character] = ACTIONS(172),
    [sym__pattern_character] = ACTIONS(172),
    [sym_null_character] = ACTIONS(172),
  },
  [35] = {
    [ts_builtin_sym_end] = ACTIONS(176),
    [sym_disjunction_delimiter] = ACTIONS(176),
    [anon_sym_STAR] = ACTIONS(176),
    [anon_sym_QMARK] = ACTIONS(176),
    [anon_sym_PLUS] = ACTIONS(176),
    [anon_sym_LBRACE] = ACTIONS(176),
    [anon_sym_BSLASH] = ACTIONS(178),
    [anon_sym_BSLASHk_LT] = ACTIONS(176),
    [sym_group_begin] = ACTIONS(176),
    [sym_group_end] = ACTIONS(176),
    [anon_sym_LBRACK] = ACTIONS(176),
    [anon_sym_CARET] = ACTIONS(176),
    [anon_sym_BSLASHb] = ACTIONS(176),
    [sym_character_class_escape] = ACTIONS(176),
    [anon_sym_BSLASH0] = ACTIONS(176),
    [anon_sym_BSLASHu] = ACTIONS(176),
    [anon_sym_BSLASHx] = ACTIONS(176),
    [anon_sym_BSLASHc] = ACTIONS(176),
    [sym_special_escape] = ACTIONS(176),
    [sym_end_assertion] = ACTIONS(176),
    [sym_non_boundary_assertion] = ACTIONS(176),
    [sym_any_character] = ACTIONS(176),
    [sym__pattern_character] = ACTIONS(176),
    [sym_null_character] = ACTIONS(176),
  },
  [36] = {
    [ts_builtin_sym_end] = ACTIONS(180),
    [sym_disjunction_delimiter] = ACTIONS(180),
    [anon_sym_STAR] = ACTIONS(180),
    [anon_sym_QMARK] = ACTIONS(180),
    [anon_sym_PLUS] = ACTIONS(180),
    [anon_sym_LBRACE] = ACTIONS(180),
    [anon_sym_BSLASH] = ACTIONS(182),
    [anon_sym_BSLASHk_LT] = ACTIONS(180),
    [sym_group_begin] = ACTIONS(180),
    [sym_group_end] = ACTIONS(180),
    [anon_sym_LBRACK] = ACTIONS(180),
    [anon_sym_CARET] = ACTIONS(180),
    [anon_sym_BSLASHb] = ACTIONS(180),
    [sym_character_class_escape] = ACTIONS(180),
    [anon_sym_BSLASH0] = ACTIONS(180),
    [anon_sym_BSLASHu] = ACTIONS(180),
    [anon_sym_BSLASHx] = ACTIONS(180),
    [anon_sym_BSLASHc] = ACTIONS(180),
    [sym_special_escape] = ACTIONS(180),
    [sym_end_assertion] = ACTIONS(180),
    [sym_non_boundary_assertion] = ACTIONS(180),
    [sym_any_character] = ACTIONS(180),
    [sym__pattern_character] = ACTIONS(180),
    [sym_null_character] = ACTIONS(180),
  },
  [37] = {
    [ts_builtin_sym_end] = ACTIONS(184),
    [sym_disjunction_delimiter] = ACTIONS(184),
    [anon_sym_STAR] = ACTIONS(184),
    [anon_sym_QMARK] = ACTIONS(184),
    [anon_sym_PLUS] = ACTIONS(184),
    [anon_sym_LBRACE] = ACTIONS(184),
    [anon_sym_BSLASH] = ACTIONS(186),
    [anon_sym_BSLASHk_LT] = ACTIONS(184),
    [sym_group_begin] = ACTIONS(184),
    [sym_group_end] = ACTIONS(184),
    [anon_sym_LBRACK] = ACTIONS(184),
    [anon_sym_CARET] = ACTIONS(184),
    [anon_sym_BSLASHb] = ACTIONS(184),
    [sym_character_class_escape] = ACTIONS(184),
    [anon_sym_BSLASH0] = ACTIONS(184),
    [anon_sym_BSLASHu] = ACTIONS(184),
    [anon_sym_BSLASHx] = ACTIONS(184),
    [anon_sym_BSLASHc] = ACTIONS(184),
    [sym_special_escape] = ACTIONS(184),
    [sym_end_assertion] = ACTIONS(184),
    [sym_non_boundary_assertion] = ACTIONS(184),
    [sym_any_character] = ACTIONS(184),
    [sym__pattern_character] = ACTIONS(184),
    [sym_null_character] = ACTIONS(184),
  },
  [38] = {
    [ts_builtin_sym_end] = ACTIONS(188),
    [sym_disjunction_delimiter] = ACTIONS(188),
    [anon_sym_STAR] = ACTIONS(188),
    [anon_sym_QMARK] = ACTIONS(188),
    [anon_sym_PLUS] = ACTIONS(188),
    [anon_sym_LBRACE] = ACTIONS(188),
    [anon_sym_BSLASH] = ACTIONS(190),
    [anon_sym_BSLASHk_LT] = ACTIONS(188),
    [sym_group_begin] = ACTIONS(188),
    [sym_group_end] = ACTIONS(188),
    [anon_sym_LBRACK] = ACTIONS(188),
    [anon_sym_CARET] = ACTIONS(188),
    [anon_sym_BSLASHb] = ACTIONS(188),
    [sym_character_class_escape] = ACTIONS(188),
    [anon_sym_BSLASH0] = ACTIONS(188),
    [anon_sym_BSLASHu] = ACTIONS(188),
    [anon_sym_BSLASHx] = ACTIONS(188),
    [anon_sym_BSLASHc] = ACTIONS(188),
    [sym_special_escape] = ACTIONS(188),
    [sym_end_assertion] = ACTIONS(188),
    [sym_non_boundary_assertion] = ACTIONS(188),
    [sym_any_character] = ACTIONS(188),
    [sym__pattern_character] = ACTIONS(188),
    [sym_null_character] = ACTIONS(188),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(192),
    [sym_disjunction_delimiter] = ACTIONS(192),
    [anon_sym_STAR] = ACTIONS(192),
    [anon_sym_QMARK] = ACTIONS(192),
    [anon_sym_PLUS] = ACTIONS(192),
    [anon_sym_LBRACE] = ACTIONS(192),
    [anon_sym_BSLASH] = ACTIONS(194),
    [anon_sym_BSLASHk_LT] = ACTIONS(192),
    [sym_group_begin] = ACTIONS(192),
    [sym_group_end] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(192),
    [anon_sym_CARET] = ACTIONS(192),
    [anon_sym_BSLASHb] = ACTIONS(192),
    [sym_character_class_escape] = ACTIONS(192),
    [anon_sym_BSLASH0] = ACTIONS(192),
    [anon_sym_BSLASHu] = ACTIONS(192),
    [anon_sym_BSLASHx] = ACTIONS(192),
    [anon_sym_BSLASHc] = ACTIONS(192),
    [sym_special_escape] = ACTIONS(192),
    [sym_end_assertion] = ACTIONS(192),
    [sym_non_boundary_assertion] = ACTIONS(192),
    [sym_any_character] = ACTIONS(192),
    [sym__pattern_character] = ACTIONS(192),
    [sym_null_character] = ACTIONS(192),
  },
  [40] = {
    [ts_builtin_sym_end] = ACTIONS(196),
    [sym_disjunction_delimiter] = ACTIONS(196),
    [anon_sym_STAR] = ACTIONS(196),
    [anon_sym_QMARK] = ACTIONS(196),
    [anon_sym_PLUS] = ACTIONS(196),
    [anon_sym_LBRACE] = ACTIONS(196),
    [anon_sym_BSLASH] = ACTIONS(198),
    [anon_sym_BSLASHk_LT] = ACTIONS(196),
    [sym_group_begin] = ACTIONS(196),
    [sym_group_end] = ACTIONS(196),
    [anon_sym_LBRACK] = ACTIONS(196),
    [anon_sym_CARET] = ACTIONS(196),
    [anon_sym_BSLASHb] = ACTIONS(196),
    [sym_character_class_escape] = ACTIONS(196),
    [anon_sym_BSLASH0] = ACTIONS(196),
    [anon_sym_BSLASHu] = ACTIONS(196),
    [anon_sym_BSLASHx] = ACTIONS(196),
    [anon_sym_BSLASHc] = ACTIONS(196),
    [sym_special_escape] = ACTIONS(196),
    [sym_end_assertion] = ACTIONS(196),
    [sym_non_boundary_assertion] = ACTIONS(196),
    [sym_any_character] = ACTIONS(196),
    [sym__pattern_character] = ACTIONS(196),
    [sym_null_character] = ACTIONS(196),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(200),
    [sym_disjunction_delimiter] = ACTIONS(200),
    [anon_sym_STAR] = ACTIONS(200),
    [anon_sym_QMARK] = ACTIONS(200),
    [anon_sym_PLUS] = ACTIONS(200),
    [anon_sym_LBRACE] = ACTIONS(200),
    [anon_sym_BSLASH] = ACTIONS(202),
    [anon_sym_BSLASHk_LT] = ACTIONS(200),
    [sym_group_begin] = ACTIONS(200),
    [sym_group_end] = ACTIONS(200),
    [anon_sym_LBRACK] = ACTIONS(200),
    [anon_sym_CARET] = ACTIONS(200),
    [anon_sym_BSLASHb] = ACTIONS(200),
    [sym_character_class_escape] = ACTIONS(200),
    [anon_sym_BSLASH0] = ACTIONS(200),
    [anon_sym_BSLASHu] = ACTIONS(200),
    [anon_sym_BSLASHx] = ACTIONS(200),
    [anon_sym_BSLASHc] = ACTIONS(200),
    [sym_special_escape] = ACTIONS(200),
    [sym_end_assertion] = ACTIONS(200),
    [sym_non_boundary_assertion] = ACTIONS(200),
    [sym_any_character] = ACTIONS(200),
    [sym__pattern_character] = ACTIONS(200),
    [sym_null_character] = ACTIONS(200),
  },
  [42] = {
    [ts_builtin_sym_end] = ACTIONS(204),
    [sym_disjunction_delimiter] = ACTIONS(204),
    [anon_sym_STAR] = ACTIONS(204),
    [anon_sym_QMARK] = ACTIONS(204),
    [anon_sym_PLUS] = ACTIONS(204),
    [anon_sym_LBRACE] = ACTIONS(204),
    [anon_sym_BSLASH] = ACTIONS(206),
    [anon_sym_BSLASHk_LT] = ACTIONS(204),
    [sym_group_begin] = ACTIONS(204),
    [sym_group_end] = ACTIONS(204),
    [anon_sym_LBRACK] = ACTIONS(204),
    [anon_sym_CARET] = ACTIONS(204),
    [anon_sym_BSLASHb] = ACTIONS(204),
    [sym_character_class_escape] = ACTIONS(204),
    [anon_sym_BSLASH0] = ACTIONS(204),
    [anon_sym_BSLASHu] = ACTIONS(204),
    [anon_sym_BSLASHx] = ACTIONS(204),
    [anon_sym_BSLASHc] = ACTIONS(204),
    [sym_special_escape] = ACTIONS(204),
    [sym_end_assertion] = ACTIONS(204),
    [sym_non_boundary_assertion] = ACTIONS(204),
    [sym_any_character] = ACTIONS(204),
    [sym__pattern_character] = ACTIONS(204),
    [sym_null_character] = ACTIONS(204),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(208),
    [sym_disjunction_delimiter] = ACTIONS(208),
    [anon_sym_STAR] = ACTIONS(208),
    [anon_sym_QMARK] = ACTIONS(208),
    [anon_sym_PLUS] = ACTIONS(208),
    [anon_sym_LBRACE] = ACTIONS(208),
    [anon_sym_BSLASH] = ACTIONS(210),
    [anon_sym_BSLASHk_LT] = ACTIONS(208),
    [sym_group_begin] = ACTIONS(208),
    [sym_group_end] = ACTIONS(208),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_CARET] = ACTIONS(208),
    [anon_sym_BSLASHb] = ACTIONS(208),
    [sym_character_class_escape] = ACTIONS(208),
    [anon_sym_BSLASH0] = ACTIONS(208),
    [anon_sym_BSLASHu] = ACTIONS(208),
    [anon_sym_BSLASHx] = ACTIONS(208),
    [anon_sym_BSLASHc] = ACTIONS(208),
    [sym_special_escape] = ACTIONS(208),
    [sym_end_assertion] = ACTIONS(208),
    [sym_non_boundary_assertion] = ACTIONS(208),
    [sym_any_character] = ACTIONS(208),
    [sym__pattern_character] = ACTIONS(208),
    [sym_null_character] = ACTIONS(208),
  },
  [44] = {
    [ts_builtin_sym_end] = ACTIONS(212),
    [sym_disjunction_delimiter] = ACTIONS(212),
    [anon_sym_STAR] = ACTIONS(212),
    [anon_sym_QMARK] = ACTIONS(212),
    [anon_sym_PLUS] = ACTIONS(212),
    [anon_sym_LBRACE] = ACTIONS(212),
    [anon_sym_BSLASH] = ACTIONS(214),
    [anon_sym_BSLASHk_LT] = ACTIONS(212),
    [sym_group_begin] = ACTIONS(212),
    [sym_group_end] = ACTIONS(212),
    [anon_sym_LBRACK] = ACTIONS(212),
    [anon_sym_CARET] = ACTIONS(212),
    [anon_sym_BSLASHb] = ACTIONS(212),
    [sym_character_class_escape] = ACTIONS(212),
    [anon_sym_BSLASH0] = ACTIONS(212),
    [anon_sym_BSLASHu] = ACTIONS(212),
    [anon_sym_BSLASHx] = ACTIONS(212),
    [anon_sym_BSLASHc] = ACTIONS(212),
    [sym_special_escape] = ACTIONS(212),
    [sym_end_assertion] = ACTIONS(212),
    [sym_non_boundary_assertion] = ACTIONS(212),
    [sym_any_character] = ACTIONS(212),
    [sym__pattern_character] = ACTIONS(212),
    [sym_null_character] = ACTIONS(212),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(216),
    [sym_disjunction_delimiter] = ACTIONS(216),
    [anon_sym_STAR] = ACTIONS(216),
    [anon_sym_QMARK] = ACTIONS(216),
    [anon_sym_PLUS] = ACTIONS(216),
    [anon_sym_LBRACE] = ACTIONS(216),
    [anon_sym_BSLASH] = ACTIONS(218),
    [anon_sym_BSLASHk_LT] = ACTIONS(216),
    [sym_group_begin] = ACTIONS(216),
    [sym_group_end] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(216),
    [anon_sym_CARET] = ACTIONS(216),
    [anon_sym_BSLASHb] = ACTIONS(216),
    [sym_character_class_escape] = ACTIONS(216),
    [anon_sym_BSLASH0] = ACTIONS(216),
    [anon_sym_BSLASHu] = ACTIONS(216),
    [anon_sym_BSLASHx] = ACTIONS(216),
    [anon_sym_BSLASHc] = ACTIONS(216),
    [sym_special_escape] = ACTIONS(216),
    [sym_end_assertion] = ACTIONS(216),
    [sym_non_boundary_assertion] = ACTIONS(216),
    [sym_any_character] = ACTIONS(216),
    [sym__pattern_character] = ACTIONS(216),
    [sym_null_character] = ACTIONS(216),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(220),
    [sym_disjunction_delimiter] = ACTIONS(220),
    [anon_sym_STAR] = ACTIONS(220),
    [anon_sym_QMARK] = ACTIONS(220),
    [anon_sym_PLUS] = ACTIONS(220),
    [anon_sym_LBRACE] = ACTIONS(220),
    [anon_sym_BSLASH] = ACTIONS(222),
    [anon_sym_BSLASHk_LT] = ACTIONS(220),
    [sym_group_begin] = ACTIONS(220),
    [sym_group_end] = ACTIONS(220),
    [anon_sym_LBRACK] = ACTIONS(220),
    [anon_sym_CARET] = ACTIONS(220),
    [anon_sym_BSLASHb] = ACTIONS(220),
    [sym_character_class_escape] = ACTIONS(220),
    [anon_sym_BSLASH0] = ACTIONS(220),
    [anon_sym_BSLASHu] = ACTIONS(220),
    [anon_sym_BSLASHx] = ACTIONS(220),
    [anon_sym_BSLASHc] = ACTIONS(220),
    [sym_special_escape] = ACTIONS(220),
    [sym_end_assertion] = ACTIONS(220),
    [sym_non_boundary_assertion] = ACTIONS(220),
    [sym_any_character] = ACTIONS(220),
    [sym__pattern_character] = ACTIONS(220),
    [sym_null_character] = ACTIONS(220),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(224),
    [sym_disjunction_delimiter] = ACTIONS(224),
    [anon_sym_STAR] = ACTIONS(224),
    [anon_sym_QMARK] = ACTIONS(224),
    [anon_sym_PLUS] = ACTIONS(224),
    [anon_sym_LBRACE] = ACTIONS(224),
    [anon_sym_BSLASH] = ACTIONS(226),
    [anon_sym_BSLASHk_LT] = ACTIONS(224),
    [sym_group_begin] = ACTIONS(224),
    [sym_group_end] = ACTIONS(224),
    [anon_sym_LBRACK] = ACTIONS(224),
    [anon_sym_CARET] = ACTIONS(224),
    [anon_sym_BSLASHb] = ACTIONS(224),
    [sym_character_class_escape] = ACTIONS(224),
    [anon_sym_BSLASH0] = ACTIONS(224),
    [anon_sym_BSLASHu] = ACTIONS(224),
    [anon_sym_BSLASHx] = ACTIONS(224),
    [anon_sym_BSLASHc] = ACTIONS(224),
    [sym_special_escape] = ACTIONS(224),
    [sym_end_assertion] = ACTIONS(224),
    [sym_non_boundary_assertion] = ACTIONS(224),
    [sym_any_character] = ACTIONS(224),
    [sym__pattern_character] = ACTIONS(224),
    [sym_null_character] = ACTIONS(224),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(228),
    [sym_disjunction_delimiter] = ACTIONS(228),
    [anon_sym_STAR] = ACTIONS(228),
    [anon_sym_QMARK] = ACTIONS(228),
    [anon_sym_PLUS] = ACTIONS(228),
    [anon_sym_LBRACE] = ACTIONS(228),
    [anon_sym_BSLASH] = ACTIONS(230),
    [anon_sym_BSLASHk_LT] = ACTIONS(228),
    [sym_group_begin] = ACTIONS(228),
    [sym_group_end] = ACTIONS(228),
    [anon_sym_LBRACK] = ACTIONS(228),
    [anon_sym_CARET] = ACTIONS(228),
    [anon_sym_BSLASHb] = ACTIONS(228),
    [sym_character_class_escape] = ACTIONS(228),
    [anon_sym_BSLASH0] = ACTIONS(228),
    [anon_sym_BSLASHu] = ACTIONS(228),
    [anon_sym_BSLASHx] = ACTIONS(228),
    [anon_sym_BSLASHc] = ACTIONS(228),
    [sym_special_escape] = ACTIONS(228),
    [sym_end_assertion] = ACTIONS(228),
    [sym_non_boundary_assertion] = ACTIONS(228),
    [sym_any_character] = ACTIONS(228),
    [sym__pattern_character] = ACTIONS(228),
    [sym_null_character] = ACTIONS(228),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(232),
    [sym_disjunction_delimiter] = ACTIONS(232),
    [anon_sym_STAR] = ACTIONS(232),
    [anon_sym_QMARK] = ACTIONS(232),
    [anon_sym_PLUS] = ACTIONS(232),
    [anon_sym_LBRACE] = ACTIONS(232),
    [anon_sym_BSLASH] = ACTIONS(234),
    [anon_sym_BSLASHk_LT] = ACTIONS(232),
    [sym_group_begin] = ACTIONS(232),
    [sym_group_end] = ACTIONS(232),
    [anon_sym_LBRACK] = ACTIONS(232),
    [anon_sym_CARET] = ACTIONS(232),
    [anon_sym_BSLASHb] = ACTIONS(232),
    [sym_character_class_escape] = ACTIONS(232),
    [anon_sym_BSLASH0] = ACTIONS(232),
    [anon_sym_BSLASHu] = ACTIONS(232),
    [anon_sym_BSLASHx] = ACTIONS(232),
    [anon_sym_BSLASHc] = ACTIONS(232),
    [sym_special_escape] = ACTIONS(232),
    [sym_end_assertion] = ACTIONS(232),
    [sym_non_boundary_assertion] = ACTIONS(232),
    [sym_any_character] = ACTIONS(232),
    [sym__pattern_character] = ACTIONS(232),
    [sym_null_character] = ACTIONS(232),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(236),
    [sym_disjunction_delimiter] = ACTIONS(236),
    [anon_sym_STAR] = ACTIONS(236),
    [anon_sym_QMARK] = ACTIONS(236),
    [anon_sym_PLUS] = ACTIONS(236),
    [anon_sym_LBRACE] = ACTIONS(236),
    [anon_sym_BSLASH] = ACTIONS(238),
    [anon_sym_BSLASHk_LT] = ACTIONS(236),
    [sym_group_begin] = ACTIONS(236),
    [sym_group_end] = ACTIONS(236),
    [anon_sym_LBRACK] = ACTIONS(236),
    [anon_sym_CARET] = ACTIONS(236),
    [anon_sym_BSLASHb] = ACTIONS(236),
    [sym_character_class_escape] = ACTIONS(236),
    [anon_sym_BSLASH0] = ACTIONS(236),
    [anon_sym_BSLASHu] = ACTIONS(236),
    [anon_sym_BSLASHx] = ACTIONS(236),
    [anon_sym_BSLASHc] = ACTIONS(236),
    [sym_special_escape] = ACTIONS(236),
    [sym_end_assertion] = ACTIONS(236),
    [sym_non_boundary_assertion] = ACTIONS(236),
    [sym_any_character] = ACTIONS(236),
    [sym__pattern_character] = ACTIONS(236),
    [sym_null_character] = ACTIONS(236),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(240),
    [sym_disjunction_delimiter] = ACTIONS(240),
    [anon_sym_STAR] = ACTIONS(240),
    [anon_sym_QMARK] = ACTIONS(240),
    [anon_sym_PLUS] = ACTIONS(240),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_BSLASH] = ACTIONS(242),
    [anon_sym_BSLASHk_LT] = ACTIONS(240),
    [sym_group_begin] = ACTIONS(240),
    [sym_group_end] = ACTIONS(240),
    [anon_sym_LBRACK] = ACTIONS(240),
    [anon_sym_CARET] = ACTIONS(240),
    [anon_sym_BSLASHb] = ACTIONS(240),
    [sym_character_class_escape] = ACTIONS(240),
    [anon_sym_BSLASH0] = ACTIONS(240),
    [anon_sym_BSLASHu] = ACTIONS(240),
    [anon_sym_BSLASHx] = ACTIONS(240),
    [anon_sym_BSLASHc] = ACTIONS(240),
    [sym_special_escape] = ACTIONS(240),
    [sym_end_assertion] = ACTIONS(240),
    [sym_non_boundary_assertion] = ACTIONS(240),
    [sym_any_character] = ACTIONS(240),
    [sym__pattern_character] = ACTIONS(240),
    [sym_null_character] = ACTIONS(240),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(244),
    [sym_disjunction_delimiter] = ACTIONS(244),
    [anon_sym_STAR] = ACTIONS(244),
    [anon_sym_QMARK] = ACTIONS(244),
    [anon_sym_PLUS] = ACTIONS(244),
    [anon_sym_LBRACE] = ACTIONS(244),
    [anon_sym_BSLASH] = ACTIONS(246),
    [anon_sym_BSLASHk_LT] = ACTIONS(244),
    [sym_group_begin] = ACTIONS(244),
    [sym_group_end] = ACTIONS(244),
    [anon_sym_LBRACK] = ACTIONS(244),
    [anon_sym_CARET] = ACTIONS(244),
    [anon_sym_BSLASHb] = ACTIONS(244),
    [sym_character_class_escape] = ACTIONS(244),
    [anon_sym_BSLASH0] = ACTIONS(244),
    [anon_sym_BSLASHu] = ACTIONS(244),
    [anon_sym_BSLASHx] = ACTIONS(244),
    [anon_sym_BSLASHc] = ACTIONS(244),
    [sym_special_escape] = ACTIONS(244),
    [sym_end_assertion] = ACTIONS(244),
    [sym_non_boundary_assertion] = ACTIONS(244),
    [sym_any_character] = ACTIONS(244),
    [sym__pattern_character] = ACTIONS(244),
    [sym_null_character] = ACTIONS(244),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(248),
    [sym_disjunction_delimiter] = ACTIONS(248),
    [anon_sym_STAR] = ACTIONS(248),
    [anon_sym_QMARK] = ACTIONS(248),
    [anon_sym_PLUS] = ACTIONS(248),
    [anon_sym_LBRACE] = ACTIONS(248),
    [anon_sym_BSLASH] = ACTIONS(250),
    [anon_sym_BSLASHk_LT] = ACTIONS(248),
    [sym_group_begin] = ACTIONS(248),
    [sym_group_end] = ACTIONS(248),
    [anon_sym_LBRACK] = ACTIONS(248),
    [anon_sym_CARET] = ACTIONS(248),
    [anon_sym_BSLASHb] = ACTIONS(248),
    [sym_character_class_escape] = ACTIONS(248),
    [anon_sym_BSLASH0] = ACTIONS(248),
    [anon_sym_BSLASHu] = ACTIONS(248),
    [anon_sym_BSLASHx] = ACTIONS(248),
    [anon_sym_BSLASHc] = ACTIONS(248),
    [sym_special_escape] = ACTIONS(248),
    [sym_end_assertion] = ACTIONS(248),
    [sym_non_boundary_assertion] = ACTIONS(248),
    [sym_any_character] = ACTIONS(248),
    [sym__pattern_character] = ACTIONS(248),
    [sym_null_character] = ACTIONS(248),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(252),
    [sym_disjunction_delimiter] = ACTIONS(252),
    [anon_sym_STAR] = ACTIONS(252),
    [anon_sym_QMARK] = ACTIONS(252),
    [anon_sym_PLUS] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(252),
    [anon_sym_BSLASH] = ACTIONS(254),
    [anon_sym_BSLASHk_LT] = ACTIONS(252),
    [sym_group_begin] = ACTIONS(252),
    [sym_group_end] = ACTIONS(252),
    [anon_sym_LBRACK] = ACTIONS(252),
    [anon_sym_CARET] = ACTIONS(252),
    [anon_sym_BSLASHb] = ACTIONS(252),
    [sym_character_class_escape] = ACTIONS(252),
    [anon_sym_BSLASH0] = ACTIONS(252),
    [anon_sym_BSLASHu] = ACTIONS(252),
    [anon_sym_BSLASHx] = ACTIONS(252),
    [anon_sym_BSLASHc] = ACTIONS(252),
    [sym_special_escape] = ACTIONS(252),
    [sym_end_assertion] = ACTIONS(252),
    [sym_non_boundary_assertion] = ACTIONS(252),
    [sym_any_character] = ACTIONS(252),
    [sym__pattern_character] = ACTIONS(252),
    [sym_null_character] = ACTIONS(252),
  },
  [55] = {
    [sym_character_range] = STATE(56),
    [sym_set_octal_escape] = STATE(84),
    [sym_set_identity_escape] = STATE(84),
    [sym_identity_escape] = STATE(84),
    [sym_octal_escape] = STATE(84),
    [sym_unicode_escape] = STATE(84),
    [sym_hexadecimal_escape] = STATE(84),
    [sym_control_letter_escape] = STATE(84),
    [sym_escape_operator] = STATE(97),
    [aux_sym_character_set_repeat1] = STATE(56),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_CARET] = ACTIONS(258),
    [anon_sym_DASH] = ACTIONS(260),
    [anon_sym_RBRACK] = ACTIONS(262),
    [anon_sym_BSLASHb] = ACTIONS(264),
    [sym__set_character] = ACTIONS(266),
    [sym_character_class_escape] = ACTIONS(268),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(268),
    [sym_null_character] = ACTIONS(268),
  },
  [56] = {
    [sym_character_range] = STATE(59),
    [sym_set_octal_escape] = STATE(84),
    [sym_set_identity_escape] = STATE(84),
    [sym_identity_escape] = STATE(84),
    [sym_octal_escape] = STATE(84),
    [sym_unicode_escape] = STATE(84),
    [sym_hexadecimal_escape] = STATE(84),
    [sym_control_letter_escape] = STATE(84),
    [sym_escape_operator] = STATE(97),
    [aux_sym_character_set_repeat1] = STATE(59),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_DASH] = ACTIONS(260),
    [anon_sym_RBRACK] = ACTIONS(278),
    [anon_sym_BSLASHb] = ACTIONS(264),
    [sym__set_character] = ACTIONS(268),
    [sym_character_class_escape] = ACTIONS(268),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(268),
    [sym_null_character] = ACTIONS(268),
  },
  [57] = {
    [sym_character_range] = STATE(58),
    [sym_set_octal_escape] = STATE(84),
    [sym_set_identity_escape] = STATE(84),
    [sym_identity_escape] = STATE(84),
    [sym_octal_escape] = STATE(84),
    [sym_unicode_escape] = STATE(84),
    [sym_hexadecimal_escape] = STATE(84),
    [sym_control_letter_escape] = STATE(84),
    [sym_escape_operator] = STATE(97),
    [aux_sym_character_set_repeat1] = STATE(58),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_DASH] = ACTIONS(260),
    [anon_sym_RBRACK] = ACTIONS(280),
    [anon_sym_BSLASHb] = ACTIONS(264),
    [sym__set_character] = ACTIONS(268),
    [sym_character_class_escape] = ACTIONS(268),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(268),
    [sym_null_character] = ACTIONS(268),
  },
  [58] = {
    [sym_character_range] = STATE(59),
    [sym_set_octal_escape] = STATE(84),
    [sym_set_identity_escape] = STATE(84),
    [sym_identity_escape] = STATE(84),
    [sym_octal_escape] = STATE(84),
    [sym_unicode_escape] = STATE(84),
    [sym_hexadecimal_escape] = STATE(84),
    [sym_control_letter_escape] = STATE(84),
    [sym_escape_operator] = STATE(97),
    [aux_sym_character_set_repeat1] = STATE(59),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_DASH] = ACTIONS(260),
    [anon_sym_RBRACK] = ACTIONS(282),
    [anon_sym_BSLASHb] = ACTIONS(264),
    [sym__set_character] = ACTIONS(268),
    [sym_character_class_escape] = ACTIONS(268),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(268),
    [sym_null_character] = ACTIONS(268),
  },
  [59] = {
    [sym_character_range] = STATE(59),
    [sym_set_octal_escape] = STATE(84),
    [sym_set_identity_escape] = STATE(84),
    [sym_identity_escape] = STATE(84),
    [sym_octal_escape] = STATE(84),
    [sym_unicode_escape] = STATE(84),
    [sym_hexadecimal_escape] = STATE(84),
    [sym_control_letter_escape] = STATE(84),
    [sym_escape_operator] = STATE(97),
    [aux_sym_character_set_repeat1] = STATE(59),
    [anon_sym_BSLASH] = ACTIONS(284),
    [anon_sym_DASH] = ACTIONS(287),
    [anon_sym_RBRACK] = ACTIONS(290),
    [anon_sym_BSLASHb] = ACTIONS(292),
    [sym__set_character] = ACTIONS(295),
    [sym_character_class_escape] = ACTIONS(295),
    [anon_sym_BSLASH0] = ACTIONS(298),
    [anon_sym_BSLASHu] = ACTIONS(301),
    [anon_sym_BSLASHx] = ACTIONS(304),
    [anon_sym_BSLASHc] = ACTIONS(307),
    [sym_special_escape] = ACTIONS(295),
    [sym_null_character] = ACTIONS(295),
  },
  [60] = {
    [ts_builtin_sym_end] = ACTIONS(310),
    [sym_disjunction_delimiter] = ACTIONS(310),
    [anon_sym_QMARK] = ACTIONS(312),
    [anon_sym_BSLASH] = ACTIONS(314),
    [anon_sym_BSLASHk_LT] = ACTIONS(310),
    [sym_group_begin] = ACTIONS(310),
    [sym_group_end] = ACTIONS(310),
    [anon_sym_LBRACK] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [anon_sym_BSLASHb] = ACTIONS(310),
    [sym_character_class_escape] = ACTIONS(310),
    [anon_sym_BSLASH0] = ACTIONS(310),
    [anon_sym_BSLASHu] = ACTIONS(310),
    [anon_sym_BSLASHx] = ACTIONS(310),
    [anon_sym_BSLASHc] = ACTIONS(310),
    [sym_special_escape] = ACTIONS(310),
    [sym_end_assertion] = ACTIONS(310),
    [sym_non_boundary_assertion] = ACTIONS(310),
    [sym_any_character] = ACTIONS(310),
    [sym__pattern_character] = ACTIONS(310),
    [sym_null_character] = ACTIONS(310),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(316),
    [sym_disjunction_delimiter] = ACTIONS(316),
    [anon_sym_QMARK] = ACTIONS(318),
    [anon_sym_BSLASH] = ACTIONS(320),
    [anon_sym_BSLASHk_LT] = ACTIONS(316),
    [sym_group_begin] = ACTIONS(316),
    [sym_group_end] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(316),
    [anon_sym_BSLASHb] = ACTIONS(316),
    [sym_character_class_escape] = ACTIONS(316),
    [anon_sym_BSLASH0] = ACTIONS(316),
    [anon_sym_BSLASHu] = ACTIONS(316),
    [anon_sym_BSLASHx] = ACTIONS(316),
    [anon_sym_BSLASHc] = ACTIONS(316),
    [sym_special_escape] = ACTIONS(316),
    [sym_end_assertion] = ACTIONS(316),
    [sym_non_boundary_assertion] = ACTIONS(316),
    [sym_any_character] = ACTIONS(316),
    [sym__pattern_character] = ACTIONS(316),
    [sym_null_character] = ACTIONS(316),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(322),
    [sym_disjunction_delimiter] = ACTIONS(322),
    [anon_sym_QMARK] = ACTIONS(324),
    [anon_sym_BSLASH] = ACTIONS(326),
    [anon_sym_BSLASHk_LT] = ACTIONS(322),
    [sym_group_begin] = ACTIONS(322),
    [sym_group_end] = ACTIONS(322),
    [anon_sym_LBRACK] = ACTIONS(322),
    [anon_sym_CARET] = ACTIONS(322),
    [anon_sym_BSLASHb] = ACTIONS(322),
    [sym_character_class_escape] = ACTIONS(322),
    [anon_sym_BSLASH0] = ACTIONS(322),
    [anon_sym_BSLASHu] = ACTIONS(322),
    [anon_sym_BSLASHx] = ACTIONS(322),
    [anon_sym_BSLASHc] = ACTIONS(322),
    [sym_special_escape] = ACTIONS(322),
    [sym_end_assertion] = ACTIONS(322),
    [sym_non_boundary_assertion] = ACTIONS(322),
    [sym_any_character] = ACTIONS(322),
    [sym__pattern_character] = ACTIONS(322),
    [sym_null_character] = ACTIONS(322),
  },
  [63] = {
    [ts_builtin_sym_end] = ACTIONS(328),
    [sym_disjunction_delimiter] = ACTIONS(328),
    [anon_sym_QMARK] = ACTIONS(330),
    [anon_sym_BSLASH] = ACTIONS(332),
    [anon_sym_BSLASHk_LT] = ACTIONS(328),
    [sym_group_begin] = ACTIONS(328),
    [sym_group_end] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(328),
    [anon_sym_CARET] = ACTIONS(328),
    [anon_sym_BSLASHb] = ACTIONS(328),
    [sym_character_class_escape] = ACTIONS(328),
    [anon_sym_BSLASH0] = ACTIONS(328),
    [anon_sym_BSLASHu] = ACTIONS(328),
    [anon_sym_BSLASHx] = ACTIONS(328),
    [anon_sym_BSLASHc] = ACTIONS(328),
    [sym_special_escape] = ACTIONS(328),
    [sym_end_assertion] = ACTIONS(328),
    [sym_non_boundary_assertion] = ACTIONS(328),
    [sym_any_character] = ACTIONS(328),
    [sym__pattern_character] = ACTIONS(328),
    [sym_null_character] = ACTIONS(328),
  },
  [64] = {
    [ts_builtin_sym_end] = ACTIONS(334),
    [sym_disjunction_delimiter] = ACTIONS(334),
    [anon_sym_QMARK] = ACTIONS(336),
    [anon_sym_BSLASH] = ACTIONS(338),
    [anon_sym_BSLASHk_LT] = ACTIONS(334),
    [sym_group_begin] = ACTIONS(334),
    [sym_group_end] = ACTIONS(334),
    [anon_sym_LBRACK] = ACTIONS(334),
    [anon_sym_CARET] = ACTIONS(334),
    [anon_sym_BSLASHb] = ACTIONS(334),
    [sym_character_class_escape] = ACTIONS(334),
    [anon_sym_BSLASH0] = ACTIONS(334),
    [anon_sym_BSLASHu] = ACTIONS(334),
    [anon_sym_BSLASHx] = ACTIONS(334),
    [anon_sym_BSLASHc] = ACTIONS(334),
    [sym_special_escape] = ACTIONS(334),
    [sym_end_assertion] = ACTIONS(334),
    [sym_non_boundary_assertion] = ACTIONS(334),
    [sym_any_character] = ACTIONS(334),
    [sym__pattern_character] = ACTIONS(334),
    [sym_null_character] = ACTIONS(334),
  },
  [65] = {
    [ts_builtin_sym_end] = ACTIONS(340),
    [sym_disjunction_delimiter] = ACTIONS(340),
    [anon_sym_QMARK] = ACTIONS(342),
    [anon_sym_BSLASH] = ACTIONS(344),
    [anon_sym_BSLASHk_LT] = ACTIONS(340),
    [sym_group_begin] = ACTIONS(340),
    [sym_group_end] = ACTIONS(340),
    [anon_sym_LBRACK] = ACTIONS(340),
    [anon_sym_CARET] = ACTIONS(340),
    [anon_sym_BSLASHb] = ACTIONS(340),
    [sym_character_class_escape] = ACTIONS(340),
    [anon_sym_BSLASH0] = ACTIONS(340),
    [anon_sym_BSLASHu] = ACTIONS(340),
    [anon_sym_BSLASHx] = ACTIONS(340),
    [anon_sym_BSLASHc] = ACTIONS(340),
    [sym_special_escape] = ACTIONS(340),
    [sym_end_assertion] = ACTIONS(340),
    [sym_non_boundary_assertion] = ACTIONS(340),
    [sym_any_character] = ACTIONS(340),
    [sym__pattern_character] = ACTIONS(340),
    [sym_null_character] = ACTIONS(340),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(346),
    [sym_disjunction_delimiter] = ACTIONS(346),
    [anon_sym_BSLASH] = ACTIONS(348),
    [anon_sym_BSLASHk_LT] = ACTIONS(346),
    [sym_group_begin] = ACTIONS(346),
    [sym_group_end] = ACTIONS(346),
    [anon_sym_LBRACK] = ACTIONS(346),
    [anon_sym_CARET] = ACTIONS(346),
    [anon_sym_BSLASHb] = ACTIONS(346),
    [sym_character_class_escape] = ACTIONS(346),
    [anon_sym_BSLASH0] = ACTIONS(346),
    [anon_sym_BSLASHu] = ACTIONS(346),
    [anon_sym_BSLASHx] = ACTIONS(346),
    [anon_sym_BSLASHc] = ACTIONS(346),
    [sym_special_escape] = ACTIONS(346),
    [sym_end_assertion] = ACTIONS(346),
    [sym_non_boundary_assertion] = ACTIONS(346),
    [sym_any_character] = ACTIONS(346),
    [sym__pattern_character] = ACTIONS(346),
    [sym_null_character] = ACTIONS(346),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(350),
    [sym_disjunction_delimiter] = ACTIONS(350),
    [anon_sym_BSLASH] = ACTIONS(352),
    [anon_sym_BSLASHk_LT] = ACTIONS(350),
    [sym_group_begin] = ACTIONS(350),
    [sym_group_end] = ACTIONS(350),
    [anon_sym_LBRACK] = ACTIONS(350),
    [anon_sym_CARET] = ACTIONS(350),
    [anon_sym_BSLASHb] = ACTIONS(350),
    [sym_character_class_escape] = ACTIONS(350),
    [anon_sym_BSLASH0] = ACTIONS(350),
    [anon_sym_BSLASHu] = ACTIONS(350),
    [anon_sym_BSLASHx] = ACTIONS(350),
    [anon_sym_BSLASHc] = ACTIONS(350),
    [sym_special_escape] = ACTIONS(350),
    [sym_end_assertion] = ACTIONS(350),
    [sym_non_boundary_assertion] = ACTIONS(350),
    [sym_any_character] = ACTIONS(350),
    [sym__pattern_character] = ACTIONS(350),
    [sym_null_character] = ACTIONS(350),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(354),
    [sym_disjunction_delimiter] = ACTIONS(354),
    [anon_sym_BSLASH] = ACTIONS(356),
    [anon_sym_BSLASHk_LT] = ACTIONS(354),
    [sym_group_begin] = ACTIONS(354),
    [sym_group_end] = ACTIONS(354),
    [anon_sym_LBRACK] = ACTIONS(354),
    [anon_sym_CARET] = ACTIONS(354),
    [anon_sym_BSLASHb] = ACTIONS(354),
    [sym_character_class_escape] = ACTIONS(354),
    [anon_sym_BSLASH0] = ACTIONS(354),
    [anon_sym_BSLASHu] = ACTIONS(354),
    [anon_sym_BSLASHx] = ACTIONS(354),
    [anon_sym_BSLASHc] = ACTIONS(354),
    [sym_special_escape] = ACTIONS(354),
    [sym_end_assertion] = ACTIONS(354),
    [sym_non_boundary_assertion] = ACTIONS(354),
    [sym_any_character] = ACTIONS(354),
    [sym__pattern_character] = ACTIONS(354),
    [sym_null_character] = ACTIONS(354),
  },
  [69] = {
    [ts_builtin_sym_end] = ACTIONS(358),
    [sym_disjunction_delimiter] = ACTIONS(358),
    [anon_sym_BSLASH] = ACTIONS(360),
    [anon_sym_BSLASHk_LT] = ACTIONS(358),
    [sym_group_begin] = ACTIONS(358),
    [sym_group_end] = ACTIONS(358),
    [anon_sym_LBRACK] = ACTIONS(358),
    [anon_sym_CARET] = ACTIONS(358),
    [anon_sym_BSLASHb] = ACTIONS(358),
    [sym_character_class_escape] = ACTIONS(358),
    [anon_sym_BSLASH0] = ACTIONS(358),
    [anon_sym_BSLASHu] = ACTIONS(358),
    [anon_sym_BSLASHx] = ACTIONS(358),
    [anon_sym_BSLASHc] = ACTIONS(358),
    [sym_special_escape] = ACTIONS(358),
    [sym_end_assertion] = ACTIONS(358),
    [sym_non_boundary_assertion] = ACTIONS(358),
    [sym_any_character] = ACTIONS(358),
    [sym__pattern_character] = ACTIONS(358),
    [sym_null_character] = ACTIONS(358),
  },
  [70] = {
    [ts_builtin_sym_end] = ACTIONS(362),
    [sym_disjunction_delimiter] = ACTIONS(362),
    [anon_sym_BSLASH] = ACTIONS(364),
    [anon_sym_BSLASHk_LT] = ACTIONS(362),
    [sym_group_begin] = ACTIONS(362),
    [sym_group_end] = ACTIONS(362),
    [anon_sym_LBRACK] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(362),
    [anon_sym_BSLASHb] = ACTIONS(362),
    [sym_character_class_escape] = ACTIONS(362),
    [anon_sym_BSLASH0] = ACTIONS(362),
    [anon_sym_BSLASHu] = ACTIONS(362),
    [anon_sym_BSLASHx] = ACTIONS(362),
    [anon_sym_BSLASHc] = ACTIONS(362),
    [sym_special_escape] = ACTIONS(362),
    [sym_end_assertion] = ACTIONS(362),
    [sym_non_boundary_assertion] = ACTIONS(362),
    [sym_any_character] = ACTIONS(362),
    [sym__pattern_character] = ACTIONS(362),
    [sym_null_character] = ACTIONS(362),
  },
  [71] = {
    [ts_builtin_sym_end] = ACTIONS(59),
    [sym_disjunction_delimiter] = ACTIONS(59),
    [anon_sym_BSLASH] = ACTIONS(366),
    [anon_sym_BSLASHk_LT] = ACTIONS(59),
    [sym_group_begin] = ACTIONS(59),
    [sym_group_end] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(59),
    [anon_sym_CARET] = ACTIONS(59),
    [anon_sym_BSLASHb] = ACTIONS(59),
    [sym_character_class_escape] = ACTIONS(59),
    [anon_sym_BSLASH0] = ACTIONS(59),
    [anon_sym_BSLASHu] = ACTIONS(59),
    [anon_sym_BSLASHx] = ACTIONS(59),
    [anon_sym_BSLASHc] = ACTIONS(59),
    [sym_special_escape] = ACTIONS(59),
    [sym_end_assertion] = ACTIONS(59),
    [sym_non_boundary_assertion] = ACTIONS(59),
    [sym_any_character] = ACTIONS(59),
    [sym__pattern_character] = ACTIONS(59),
    [sym_null_character] = ACTIONS(59),
  },
  [72] = {
    [ts_builtin_sym_end] = ACTIONS(368),
    [sym_disjunction_delimiter] = ACTIONS(368),
    [anon_sym_BSLASH] = ACTIONS(370),
    [anon_sym_BSLASHk_LT] = ACTIONS(368),
    [sym_group_begin] = ACTIONS(368),
    [sym_group_end] = ACTIONS(368),
    [anon_sym_LBRACK] = ACTIONS(368),
    [anon_sym_CARET] = ACTIONS(368),
    [anon_sym_BSLASHb] = ACTIONS(368),
    [sym_character_class_escape] = ACTIONS(368),
    [anon_sym_BSLASH0] = ACTIONS(368),
    [anon_sym_BSLASHu] = ACTIONS(368),
    [anon_sym_BSLASHx] = ACTIONS(368),
    [anon_sym_BSLASHc] = ACTIONS(368),
    [sym_special_escape] = ACTIONS(368),
    [sym_end_assertion] = ACTIONS(368),
    [sym_non_boundary_assertion] = ACTIONS(368),
    [sym_any_character] = ACTIONS(368),
    [sym__pattern_character] = ACTIONS(368),
    [sym_null_character] = ACTIONS(368),
  },
  [73] = {
    [sym_set_octal_escape] = STATE(88),
    [sym_set_identity_escape] = STATE(88),
    [sym_identity_escape] = STATE(88),
    [sym_octal_escape] = STATE(88),
    [sym_unicode_escape] = STATE(88),
    [sym_hexadecimal_escape] = STATE(88),
    [sym_control_letter_escape] = STATE(88),
    [sym_escape_operator] = STATE(97),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_RBRACK] = ACTIONS(290),
    [anon_sym_BSLASHb] = ACTIONS(374),
    [sym__set_character] = ACTIONS(372),
    [sym_character_class_escape] = ACTIONS(372),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(372),
    [sym_null_character] = ACTIONS(372),
  },
  [74] = {
    [sym_set_octal_escape] = STATE(87),
    [sym_set_identity_escape] = STATE(87),
    [sym_identity_escape] = STATE(87),
    [sym_octal_escape] = STATE(87),
    [sym_unicode_escape] = STATE(87),
    [sym_hexadecimal_escape] = STATE(87),
    [sym_control_letter_escape] = STATE(87),
    [sym_escape_operator] = STATE(97),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_RBRACK] = ACTIONS(378),
    [anon_sym_BSLASHb] = ACTIONS(380),
    [sym__set_character] = ACTIONS(376),
    [sym_character_class_escape] = ACTIONS(376),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(376),
    [sym_null_character] = ACTIONS(376),
  },
  [75] = {
    [sym_set_octal_escape] = STATE(88),
    [sym_set_identity_escape] = STATE(88),
    [sym_identity_escape] = STATE(88),
    [sym_octal_escape] = STATE(88),
    [sym_unicode_escape] = STATE(88),
    [sym_hexadecimal_escape] = STATE(88),
    [sym_control_letter_escape] = STATE(88),
    [sym_escape_operator] = STATE(97),
    [anon_sym_BSLASH] = ACTIONS(256),
    [anon_sym_DASH] = ACTIONS(372),
    [anon_sym_BSLASHb] = ACTIONS(374),
    [sym__set_character] = ACTIONS(372),
    [sym_character_class_escape] = ACTIONS(372),
    [anon_sym_BSLASH0] = ACTIONS(270),
    [anon_sym_BSLASHu] = ACTIONS(272),
    [anon_sym_BSLASHx] = ACTIONS(274),
    [anon_sym_BSLASHc] = ACTIONS(276),
    [sym_special_escape] = ACTIONS(372),
    [sym_null_character] = ACTIONS(372),
  },
  [76] = {
    [anon_sym_BSLASH] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(384),
    [anon_sym_RBRACK] = ACTIONS(384),
    [anon_sym_BSLASHb] = ACTIONS(384),
    [sym__set_character] = ACTIONS(384),
    [sym_character_class_escape] = ACTIONS(384),
    [anon_sym_BSLASH0] = ACTIONS(384),
    [anon_sym_BSLASHu] = ACTIONS(384),
    [anon_sym_BSLASHx] = ACTIONS(384),
    [anon_sym_BSLASHc] = ACTIONS(384),
    [sym_special_escape] = ACTIONS(384),
    [sym_null_character] = ACTIONS(384),
  },
  [77] = {
    [anon_sym_BSLASH] = ACTIONS(210),
    [anon_sym_DASH] = ACTIONS(208),
    [anon_sym_RBRACK] = ACTIONS(208),
    [anon_sym_BSLASHb] = ACTIONS(208),
    [sym__set_character] = ACTIONS(208),
    [sym_character_class_escape] = ACTIONS(208),
    [anon_sym_BSLASH0] = ACTIONS(208),
    [anon_sym_BSLASHu] = ACTIONS(208),
    [anon_sym_BSLASHx] = ACTIONS(208),
    [anon_sym_BSLASHc] = ACTIONS(208),
    [sym_special_escape] = ACTIONS(208),
    [sym_null_character] = ACTIONS(208),
  },
  [78] = {
    [anon_sym_BSLASH] = ACTIONS(222),
    [anon_sym_DASH] = ACTIONS(220),
    [anon_sym_RBRACK] = ACTIONS(220),
    [anon_sym_BSLASHb] = ACTIONS(220),
    [sym__set_character] = ACTIONS(220),
    [sym_character_class_escape] = ACTIONS(220),
    [anon_sym_BSLASH0] = ACTIONS(220),
    [anon_sym_BSLASHu] = ACTIONS(220),
    [anon_sym_BSLASHx] = ACTIONS(220),
    [anon_sym_BSLASHc] = ACTIONS(220),
    [sym_special_escape] = ACTIONS(220),
    [sym_null_character] = ACTIONS(220),
  },
  [79] = {
    [anon_sym_BSLASH] = ACTIONS(218),
    [anon_sym_DASH] = ACTIONS(216),
    [anon_sym_RBRACK] = ACTIONS(216),
    [anon_sym_BSLASHb] = ACTIONS(216),
    [sym__set_character] = ACTIONS(216),
    [sym_character_class_escape] = ACTIONS(216),
    [anon_sym_BSLASH0] = ACTIONS(216),
    [anon_sym_BSLASHu] = ACTIONS(216),
    [anon_sym_BSLASHx] = ACTIONS(216),
    [anon_sym_BSLASHc] = ACTIONS(216),
    [sym_special_escape] = ACTIONS(216),
    [sym_null_character] = ACTIONS(216),
  },
  [80] = {
    [anon_sym_BSLASH] = ACTIONS(386),
    [anon_sym_DASH] = ACTIONS(388),
    [anon_sym_RBRACK] = ACTIONS(388),
    [anon_sym_BSLASHb] = ACTIONS(388),
    [sym__set_character] = ACTIONS(388),
    [sym_character_class_escape] = ACTIONS(388),
    [anon_sym_BSLASH0] = ACTIONS(388),
    [anon_sym_BSLASHu] = ACTIONS(388),
    [anon_sym_BSLASHx] = ACTIONS(388),
    [anon_sym_BSLASHc] = ACTIONS(388),
    [sym_special_escape] = ACTIONS(388),
    [sym_null_character] = ACTIONS(388),
  },
  [81] = {
    [anon_sym_BSLASH] = ACTIONS(214),
    [anon_sym_DASH] = ACTIONS(212),
    [anon_sym_RBRACK] = ACTIONS(212),
    [anon_sym_BSLASHb] = ACTIONS(212),
    [sym__set_character] = ACTIONS(212),
    [sym_character_class_escape] = ACTIONS(212),
    [anon_sym_BSLASH0] = ACTIONS(212),
    [anon_sym_BSLASHu] = ACTIONS(212),
    [anon_sym_BSLASHx] = ACTIONS(212),
    [anon_sym_BSLASHc] = ACTIONS(212),
    [sym_special_escape] = ACTIONS(212),
    [sym_null_character] = ACTIONS(212),
  },
  [82] = {
    [anon_sym_BSLASH] = ACTIONS(206),
    [anon_sym_DASH] = ACTIONS(204),
    [anon_sym_RBRACK] = ACTIONS(204),
    [anon_sym_BSLASHb] = ACTIONS(204),
    [sym__set_character] = ACTIONS(204),
    [sym_character_class_escape] = ACTIONS(204),
    [anon_sym_BSLASH0] = ACTIONS(204),
    [anon_sym_BSLASHu] = ACTIONS(204),
    [anon_sym_BSLASHx] = ACTIONS(204),
    [anon_sym_BSLASHc] = ACTIONS(204),
    [sym_special_escape] = ACTIONS(204),
    [sym_null_character] = ACTIONS(204),
  },
  [83] = {
    [anon_sym_BSLASH] = ACTIONS(390),
    [anon_sym_DASH] = ACTIONS(392),
    [anon_sym_RBRACK] = ACTIONS(392),
    [anon_sym_BSLASHb] = ACTIONS(392),
    [sym__set_character] = ACTIONS(392),
    [sym_character_class_escape] = ACTIONS(392),
    [anon_sym_BSLASH0] = ACTIONS(392),
    [anon_sym_BSLASHu] = ACTIONS(392),
    [anon_sym_BSLASHx] = ACTIONS(392),
    [anon_sym_BSLASHc] = ACTIONS(392),
    [sym_special_escape] = ACTIONS(392),
    [sym_null_character] = ACTIONS(392),
  },
  [84] = {
    [anon_sym_BSLASH] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(396),
    [anon_sym_RBRACK] = ACTIONS(398),
    [anon_sym_BSLASHb] = ACTIONS(398),
    [sym__set_character] = ACTIONS(398),
    [sym_character_class_escape] = ACTIONS(398),
    [anon_sym_BSLASH0] = ACTIONS(398),
    [anon_sym_BSLASHu] = ACTIONS(398),
    [anon_sym_BSLASHx] = ACTIONS(398),
    [anon_sym_BSLASHc] = ACTIONS(398),
    [sym_special_escape] = ACTIONS(398),
    [sym_null_character] = ACTIONS(398),
  },
  [85] = {
    [anon_sym_BSLASH] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(400),
    [anon_sym_RBRACK] = ACTIONS(398),
    [anon_sym_BSLASHb] = ACTIONS(398),
    [sym__set_character] = ACTIONS(398),
    [sym_character_class_escape] = ACTIONS(398),
    [anon_sym_BSLASH0] = ACTIONS(398),
    [anon_sym_BSLASHu] = ACTIONS(398),
    [anon_sym_BSLASHx] = ACTIONS(398),
    [anon_sym_BSLASHc] = ACTIONS(398),
    [sym_special_escape] = ACTIONS(398),
    [sym_null_character] = ACTIONS(398),
  },
  [86] = {
    [anon_sym_BSLASH] = ACTIONS(402),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_RBRACK] = ACTIONS(406),
    [anon_sym_BSLASHb] = ACTIONS(406),
    [sym__set_character] = ACTIONS(406),
    [sym_character_class_escape] = ACTIONS(406),
    [anon_sym_BSLASH0] = ACTIONS(406),
    [anon_sym_BSLASHu] = ACTIONS(406),
    [anon_sym_BSLASHx] = ACTIONS(406),
    [anon_sym_BSLASHc] = ACTIONS(406),
    [sym_special_escape] = ACTIONS(406),
    [sym_null_character] = ACTIONS(406),
  },
  [87] = {
    [anon_sym_BSLASH] = ACTIONS(408),
    [anon_sym_DASH] = ACTIONS(410),
    [anon_sym_RBRACK] = ACTIONS(410),
    [anon_sym_BSLASHb] = ACTIONS(410),
    [sym__set_character] = ACTIONS(410),
    [sym_character_class_escape] = ACTIONS(410),
    [anon_sym_BSLASH0] = ACTIONS(410),
    [anon_sym_BSLASHu] = ACTIONS(410),
    [anon_sym_BSLASHx] = ACTIONS(410),
    [anon_sym_BSLASHc] = ACTIONS(410),
    [sym_special_escape] = ACTIONS(410),
    [sym_null_character] = ACTIONS(410),
  },
  [88] = {
    [anon_sym_BSLASH] = ACTIONS(412),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_RBRACK] = ACTIONS(414),
    [anon_sym_BSLASHb] = ACTIONS(414),
    [sym__set_character] = ACTIONS(414),
    [sym_character_class_escape] = ACTIONS(414),
    [anon_sym_BSLASH0] = ACTIONS(414),
    [anon_sym_BSLASHu] = ACTIONS(414),
    [anon_sym_BSLASHx] = ACTIONS(414),
    [anon_sym_BSLASHc] = ACTIONS(414),
    [sym_special_escape] = ACTIONS(414),
    [sym_null_character] = ACTIONS(414),
  },
  [89] = {
    [anon_sym_BSLASH] = ACTIONS(416),
    [anon_sym_DASH] = ACTIONS(418),
    [anon_sym_RBRACK] = ACTIONS(418),
    [anon_sym_BSLASHb] = ACTIONS(418),
    [sym__set_character] = ACTIONS(418),
    [sym_character_class_escape] = ACTIONS(418),
    [anon_sym_BSLASH0] = ACTIONS(418),
    [anon_sym_BSLASHu] = ACTIONS(418),
    [anon_sym_BSLASHx] = ACTIONS(418),
    [anon_sym_BSLASHc] = ACTIONS(418),
    [sym_special_escape] = ACTIONS(418),
    [sym_null_character] = ACTIONS(418),
  },
  [90] = {
    [sym_unicode_escape] = STATE(91),
    [aux_sym_group_name_repeat1] = STATE(91),
    [anon_sym_GT] = ACTIONS(420),
    [sym__name_additional_char] = ACTIONS(422),
    [anon_sym_BSLASHu] = ACTIONS(424),
  },
  [91] = {
    [sym_unicode_escape] = STATE(92),
    [aux_sym_group_name_repeat1] = STATE(92),
    [anon_sym_GT] = ACTIONS(426),
    [sym__name_additional_char] = ACTIONS(428),
    [anon_sym_BSLASHu] = ACTIONS(424),
  },
  [92] = {
    [sym_unicode_escape] = STATE(92),
    [aux_sym_group_name_repeat1] = STATE(92),
    [anon_sym_GT] = ACTIONS(430),
    [sym__name_additional_char] = ACTIONS(432),
    [anon_sym_BSLASHu] = ACTIONS(435),
  },
  [93] = {
    [sym_group_name] = STATE(106),
    [sym_unicode_escape] = STATE(90),
    [sym__name_first_char] = ACTIONS(438),
    [anon_sym_BSLASHu] = ACTIONS(424),
  },
  [94] = {
    [sym_group_name] = STATE(102),
    [sym_unicode_escape] = STATE(90),
    [sym__name_first_char] = ACTIONS(438),
    [anon_sym_BSLASHu] = ACTIONS(424),
  },
  [95] = {
    [anon_sym_GT] = ACTIONS(208),
    [sym__name_additional_char] = ACTIONS(208),
    [anon_sym_BSLASHu] = ACTIONS(208),
  },
  [96] = {
    [aux_sym_set_octal_escape_token1] = ACTIONS(440),
    [aux_sym_set_identity_escape_token1] = ACTIONS(442),
    [aux_sym_identity_escape_token1] = ACTIONS(442),
  },
  [97] = {
    [aux_sym_set_identity_escape_token1] = ACTIONS(444),
    [aux_sym_identity_escape_token1] = ACTIONS(446),
  },
  [98] = {
    [ts_builtin_sym_end] = ACTIONS(448),
    [sym_group_end] = ACTIONS(448),
  },
  [99] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(450),
    [anon_sym_RBRACE] = ACTIONS(452),
  },
  [100] = {
    [aux_sym_backreference_escape_token1] = ACTIONS(454),
    [aux_sym_identity_escape_token1] = ACTIONS(442),
  },
  [101] = {
    [anon_sym_COMMA] = ACTIONS(456),
    [anon_sym_RBRACE] = ACTIONS(458),
  },
  [102] = {
    [anon_sym_GT] = ACTIONS(460),
  },
  [103] = {
    [aux_sym_count_quantifier_token1] = ACTIONS(462),
  },
  [104] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(464),
  },
  [105] = {
    [aux_sym_octal_escape_token1] = ACTIONS(466),
  },
  [106] = {
    [anon_sym_GT] = ACTIONS(468),
  },
  [107] = {
    [anon_sym_RBRACE] = ACTIONS(470),
  },
  [108] = {
    [sym_group_end] = ACTIONS(472),
  },
  [109] = {
    [sym_group_end] = ACTIONS(474),
  },
  [110] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(476),
  },
  [111] = {
    [sym_group_end] = ACTIONS(478),
  },
  [112] = {
    [sym_group_end] = ACTIONS(480),
  },
  [113] = {
    [ts_builtin_sym_end] = ACTIONS(482),
  },
  [114] = {
    [sym_group_end] = ACTIONS(484),
  },
  [115] = {
    [sym_group_end] = ACTIONS(486),
  },
  [116] = {
    [aux_sym_identity_escape_token1] = ACTIONS(488),
  },
  [117] = {
    [sym_group_end] = ACTIONS(490),
  },
  [118] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(492),
  },
  [119] = {
    [ts_builtin_sym_end] = ACTIONS(494),
  },
  [120] = {
    [aux_sym_octal_escape_token1] = ACTIONS(496),
  },
  [121] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(498),
  },
  [122] = {
    [aux_sym_hexadecimal_escape_token1] = ACTIONS(500),
  },
  [123] = {
    [aux_sym_control_letter_escape_token1] = ACTIONS(502),
  },
  [124] = {
    [aux_sym_unicode_escape_token1] = ACTIONS(504),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT(100),
  [5] = {.count = 1, .reusable = true}, SHIFT(94),
  [7] = {.count = 1, .reusable = true}, SHIFT(2),
  [9] = {.count = 1, .reusable = true}, SHIFT(55),
  [11] = {.count = 1, .reusable = true}, SHIFT(24),
  [13] = {.count = 1, .reusable = true}, SHIFT(31),
  [15] = {.count = 1, .reusable = true}, SHIFT(20),
  [17] = {.count = 1, .reusable = true}, SHIFT(105),
  [19] = {.count = 1, .reusable = true}, SHIFT(118),
  [21] = {.count = 1, .reusable = true}, SHIFT(110),
  [23] = {.count = 1, .reusable = true}, SHIFT(104),
  [25] = {.count = 1, .reusable = true}, SHIFT(16),
  [27] = {.count = 1, .reusable = true}, SHIFT(17),
  [29] = {.count = 1, .reusable = true}, SHIFT(18),
  [31] = {.count = 1, .reusable = true}, SHIFT(19),
  [33] = {.count = 1, .reusable = false}, SHIFT(93),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = true}, SHIFT(33),
  [39] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 2),
  [41] = {.count = 1, .reusable = true}, SHIFT(13),
  [43] = {.count = 1, .reusable = true}, SHIFT(32),
  [45] = {.count = 1, .reusable = true}, SHIFT(48),
  [47] = {.count = 1, .reusable = true}, SHIFT(30),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT(27),
  [53] = {.count = 1, .reusable = true}, SHIFT(36),
  [55] = {.count = 1, .reusable = true}, SHIFT(28),
  [57] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 1),
  [59] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2),
  [61] = {.count = 2, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(100),
  [64] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(94),
  [67] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(2),
  [70] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(55),
  [73] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(24),
  [76] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(31),
  [79] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(20),
  [82] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(105),
  [85] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(118),
  [88] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(110),
  [91] = {.count = 2, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 2), SHIFT_REPEAT(104),
  [94] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 1),
  [96] = {.count = 1, .reusable = true}, SHIFT(35),
  [98] = {.count = 1, .reusable = true}, SHIFT(21),
  [100] = {.count = 1, .reusable = true}, SHIFT(54),
  [102] = {.count = 1, .reusable = true}, SHIFT(51),
  [104] = {.count = 1, .reusable = true}, SHIFT(49),
  [106] = {.count = 1, .reusable = true}, SHIFT(41),
  [108] = {.count = 1, .reusable = true}, REDUCE(aux_sym_pattern_repeat1, 1),
  [110] = {.count = 1, .reusable = true}, SHIFT(64),
  [112] = {.count = 1, .reusable = true}, SHIFT(63),
  [114] = {.count = 1, .reusable = true}, SHIFT(62),
  [116] = {.count = 1, .reusable = true}, SHIFT(103),
  [118] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 1),
  [120] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 3),
  [122] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 3),
  [124] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [126] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 4),
  [128] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 7, .production_id = 9),
  [130] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 7, .production_id = 9),
  [132] = {.count = 1, .reusable = true}, REDUCE(sym_start_assertion, 1),
  [134] = {.count = 1, .reusable = false}, REDUCE(sym_start_assertion, 1),
  [136] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3),
  [138] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3),
  [140] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 3, .production_id = 3),
  [142] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 3, .production_id = 3),
  [144] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 4),
  [146] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 4),
  [148] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 3),
  [150] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 3),
  [152] = {.count = 1, .reusable = true}, REDUCE(sym_backreference_escape, 2),
  [154] = {.count = 1, .reusable = false}, REDUCE(sym_backreference_escape, 2),
  [156] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 6, .production_id = 9),
  [158] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 6, .production_id = 9),
  [160] = {.count = 1, .reusable = true}, REDUCE(sym_boundary_assertion, 1),
  [162] = {.count = 1, .reusable = false}, REDUCE(sym_boundary_assertion, 1),
  [164] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 4),
  [166] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 4),
  [168] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 2),
  [170] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 2),
  [172] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 5),
  [174] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 5),
  [176] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 5, .production_id = 9),
  [178] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 5, .production_id = 9),
  [180] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 4),
  [182] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 4),
  [184] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [186] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 5),
  [188] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 2),
  [190] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 2),
  [192] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 5),
  [194] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 5),
  [196] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 5),
  [198] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 5),
  [200] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [202] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookbehind_assertion, 3),
  [204] = {.count = 1, .reusable = true}, REDUCE(sym_octal_escape, 2),
  [206] = {.count = 1, .reusable = false}, REDUCE(sym_octal_escape, 2),
  [208] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_escape, 2),
  [210] = {.count = 1, .reusable = false}, REDUCE(sym_unicode_escape, 2),
  [212] = {.count = 1, .reusable = true}, REDUCE(sym_hexadecimal_escape, 2),
  [214] = {.count = 1, .reusable = false}, REDUCE(sym_hexadecimal_escape, 2),
  [216] = {.count = 1, .reusable = true}, REDUCE(sym_control_letter_escape, 2),
  [218] = {.count = 1, .reusable = false}, REDUCE(sym_control_letter_escape, 2),
  [220] = {.count = 1, .reusable = true}, REDUCE(sym_identity_escape, 2),
  [222] = {.count = 1, .reusable = false}, REDUCE(sym_identity_escape, 2),
  [224] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 5),
  [226] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 5),
  [228] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 4),
  [230] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 4),
  [232] = {.count = 1, .reusable = true}, REDUCE(sym_lookbehind_assertion, 3),
  [234] = {.count = 1, .reusable = false}, REDUCE(sym_lookbehind_assertion, 3),
  [236] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 4),
  [238] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 4),
  [240] = {.count = 1, .reusable = true}, REDUCE(sym_negative_lookahead_assertion, 3),
  [242] = {.count = 1, .reusable = false}, REDUCE(sym_negative_lookahead_assertion, 3),
  [244] = {.count = 1, .reusable = true}, REDUCE(sym_character_set, 4, .production_id = 3),
  [246] = {.count = 1, .reusable = false}, REDUCE(sym_character_set, 4, .production_id = 3),
  [248] = {.count = 1, .reusable = true}, REDUCE(sym_backreference_escape, 3),
  [250] = {.count = 1, .reusable = false}, REDUCE(sym_backreference_escape, 3),
  [252] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 3),
  [254] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 3),
  [256] = {.count = 1, .reusable = false}, SHIFT(96),
  [258] = {.count = 1, .reusable = true}, SHIFT(57),
  [260] = {.count = 1, .reusable = true}, SHIFT(85),
  [262] = {.count = 1, .reusable = true}, SHIFT(38),
  [264] = {.count = 1, .reusable = true}, SHIFT(86),
  [266] = {.count = 1, .reusable = false}, SHIFT(84),
  [268] = {.count = 1, .reusable = true}, SHIFT(84),
  [270] = {.count = 1, .reusable = true}, SHIFT(120),
  [272] = {.count = 1, .reusable = true}, SHIFT(124),
  [274] = {.count = 1, .reusable = true}, SHIFT(122),
  [276] = {.count = 1, .reusable = true}, SHIFT(123),
  [278] = {.count = 1, .reusable = true}, SHIFT(25),
  [280] = {.count = 1, .reusable = true}, SHIFT(26),
  [282] = {.count = 1, .reusable = true}, SHIFT(52),
  [284] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(96),
  [287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(85),
  [290] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2),
  [292] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(86),
  [295] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(84),
  [298] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(120),
  [301] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(124),
  [304] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(122),
  [307] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2), SHIFT_REPEAT(123),
  [310] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4),
  [312] = {.count = 1, .reusable = true}, SHIFT(70),
  [314] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4),
  [316] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5),
  [318] = {.count = 1, .reusable = true}, SHIFT(72),
  [320] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5),
  [322] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 1),
  [324] = {.count = 1, .reusable = true}, SHIFT(67),
  [326] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 1),
  [328] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 1),
  [330] = {.count = 1, .reusable = true}, SHIFT(68),
  [332] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 1),
  [334] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 1),
  [336] = {.count = 1, .reusable = true}, SHIFT(69),
  [338] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 1),
  [340] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 3),
  [342] = {.count = 1, .reusable = true}, SHIFT(66),
  [344] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 3),
  [346] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4, .production_id = 8),
  [348] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4, .production_id = 8),
  [350] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 2, .production_id = 2),
  [352] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 2, .production_id = 2),
  [354] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 2, .production_id = 2),
  [356] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 2, .production_id = 2),
  [358] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 2, .production_id = 2),
  [360] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 2, .production_id = 2),
  [362] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5, .production_id = 10),
  [364] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5, .production_id = 10),
  [366] = {.count = 1, .reusable = false}, REDUCE(aux_sym_pattern_repeat1, 2),
  [368] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 6, .production_id = 11),
  [370] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 6, .production_id = 11),
  [372] = {.count = 1, .reusable = true}, SHIFT(88),
  [374] = {.count = 1, .reusable = true}, SHIFT(89),
  [376] = {.count = 1, .reusable = true}, SHIFT(87),
  [378] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 2, .production_id = 1),
  [380] = {.count = 1, .reusable = true}, SHIFT(76),
  [382] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 7),
  [384] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 7),
  [386] = {.count = 1, .reusable = false}, REDUCE(sym_set_octal_escape, 2),
  [388] = {.count = 1, .reusable = true}, REDUCE(sym_set_octal_escape, 2),
  [390] = {.count = 1, .reusable = false}, REDUCE(sym_set_identity_escape, 2),
  [392] = {.count = 1, .reusable = true}, REDUCE(sym_set_identity_escape, 2),
  [394] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1),
  [396] = {.count = 1, .reusable = true}, SHIFT(73),
  [398] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1),
  [400] = {.count = 1, .reusable = true}, SHIFT(75),
  [402] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [404] = {.count = 1, .reusable = true}, SHIFT(74),
  [406] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_set_repeat1, 1, .production_id = 1),
  [408] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 6),
  [410] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 6),
  [412] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 4),
  [414] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 4),
  [416] = {.count = 1, .reusable = false}, REDUCE(sym_character_range, 3, .production_id = 5),
  [418] = {.count = 1, .reusable = true}, REDUCE(sym_character_range, 3, .production_id = 5),
  [420] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 1),
  [422] = {.count = 1, .reusable = true}, SHIFT(91),
  [424] = {.count = 1, .reusable = true}, SHIFT(121),
  [426] = {.count = 1, .reusable = true}, REDUCE(sym_group_name, 2),
  [428] = {.count = 1, .reusable = true}, SHIFT(92),
  [430] = {.count = 1, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2),
  [432] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(92),
  [435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_group_name_repeat1, 2), SHIFT_REPEAT(121),
  [438] = {.count = 1, .reusable = true}, SHIFT(90),
  [440] = {.count = 1, .reusable = true}, SHIFT(80),
  [442] = {.count = 1, .reusable = true}, REDUCE(sym_escape_operator, 1),
  [444] = {.count = 1, .reusable = true}, SHIFT(83),
  [446] = {.count = 1, .reusable = true}, SHIFT(78),
  [448] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 3),
  [450] = {.count = 1, .reusable = true}, SHIFT(107),
  [452] = {.count = 1, .reusable = true}, SHIFT(60),
  [454] = {.count = 1, .reusable = true}, SHIFT(29),
  [456] = {.count = 1, .reusable = true}, SHIFT(99),
  [458] = {.count = 1, .reusable = true}, SHIFT(65),
  [460] = {.count = 1, .reusable = true}, SHIFT(53),
  [462] = {.count = 1, .reusable = true}, SHIFT(101),
  [464] = {.count = 1, .reusable = true}, SHIFT(45),
  [466] = {.count = 1, .reusable = true}, SHIFT(42),
  [468] = {.count = 1, .reusable = true}, SHIFT(14),
  [470] = {.count = 1, .reusable = true}, SHIFT(61),
  [472] = {.count = 1, .reusable = true}, SHIFT(39),
  [474] = {.count = 1, .reusable = true}, SHIFT(34),
  [476] = {.count = 1, .reusable = true}, SHIFT(44),
  [478] = {.count = 1, .reusable = true}, SHIFT(23),
  [480] = {.count = 1, .reusable = true}, SHIFT(50),
  [482] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2),
  [484] = {.count = 1, .reusable = true}, SHIFT(40),
  [486] = {.count = 1, .reusable = true}, SHIFT(37),
  [488] = {.count = 1, .reusable = true}, SHIFT(46),
  [490] = {.count = 1, .reusable = true}, SHIFT(47),
  [492] = {.count = 1, .reusable = true}, SHIFT(43),
  [494] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [496] = {.count = 1, .reusable = true}, SHIFT(82),
  [498] = {.count = 1, .reusable = true}, SHIFT(95),
  [500] = {.count = 1, .reusable = true}, SHIFT(81),
  [502] = {.count = 1, .reusable = true}, SHIFT(79),
  [504] = {.count = 1, .reusable = true}, SHIFT(77),
};

void *tree_sitter_regex_external_scanner_create(void);
void tree_sitter_regex_external_scanner_destroy(void *);
bool tree_sitter_regex_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_regex_external_scanner_serialize(void *, char *);
void tree_sitter_regex_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_regex(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_regex_external_scanner_create,
      tree_sitter_regex_external_scanner_destroy,
      tree_sitter_regex_external_scanner_scan,
      tree_sitter_regex_external_scanner_serialize,
      tree_sitter_regex_external_scanner_deserialize,
    },
  };
  return &language;
}
